
' This file implements the TableControl, TableControlRow, and RecordControl classes for the 
' EditOwnerPage.aspx page.  The Row or RecordControl classes are the 
' ideal place to add code customizations. For example, you can override the LoadData, 
' CreateWhereClause, DataBind, SaveData, GetUIData, and Validate methods.

#Region "Imports statements"

Option Strict On
Imports Microsoft.VisualBasic
Imports BaseClasses.Web.UI.WebControls
Imports System
Imports System.Collections
Imports System.Web
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports BaseClasses
Imports BaseClasses.Data
Imports BaseClasses.Utils
Imports ReportTools.ReportCreator
Imports ReportTools.Shared

  
        
Imports Training1.Business
Imports Training1.Data
        

#End Region

  
Namespace Training1.UI.Controls.EditOwnerPage

#Region "Section 1: Place your customizations here."

    
Public Class OwnerRecordControl
        Inherits BaseOwnerRecordControl
        ' The BaseOwnerRecordControl implements the LoadData, DataBind and other
        ' methods to load and display the data in a table control.

        ' This is the ideal place to add your code customizations. For example, you can override the LoadData, 
        ' CreateWhereClause, DataBind, SaveData, GetUIData, and Validate methods.
        

End Class

  

Public Class OwnerVehicleTableControl
        Inherits BaseOwnerVehicleTableControl

        ' The BaseOwnerVehicleTableControl class implements the LoadData, DataBind, CreateWhereClause
        ' and other methods to load and display the data in a table control.

        ' This is the ideal place to add your code customizations. You can override the LoadData and CreateWhereClause,
        ' The OwnerVehicleTableControlRow class offers another place where you can customize
        ' the DataBind, GetUIData, SaveData and Validate methods specific to each row displayed on the table.

End Class
Public Class OwnerVehicleTableControlRow
        Inherits BaseOwnerVehicleTableControlRow
        ' The BaseOwnerVehicleTableControlRow implements code for a ROW within the
        ' the OwnerVehicleTableControl table.  The BaseOwnerVehicleTableControlRow implements the DataBind and SaveData methods.
        ' The loading of data is actually performed by the LoadData method in the base class of OwnerVehicleTableControl.

        ' This is the ideal place to add your code customizations. For example, you can override the DataBind, 
        ' SaveData, GetUIData, and Validate methods.
        


#Region "Code Customization"

        ''' <summary>
        ''' This method sets the AutoPostBack property of the field that triggers a change.
        ''' </summary>
        Private Sub MultipleDropdown_myInit(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Init
            If (Not Me.Page.IsPostBack) Then
                ' AutoPostBack sets or retrieves a value that indicates whether or not the control
                ' posts back to the server each time a user interacts with the control. 
                ' if change in second drop down list updates the first then set
                ' AutoPostback of the second dropdown list to true and implement 
                ' {Second Dropdown List Control}.SelectedIndexChanged event handler
                Make.AutoPostBack = True
                Model.AutoPostBack = True
            End If

            AddHandler Make.SelectedIndexChanged, AddressOf Make_SelectedIndexChanged
            AddHandler Model.SelectedIndexChanged, AddressOf Model_SelectedIndexChanged

            Make.Enabled = True
            Model.Enabled = False
            VehicleTypeId.Enabled = False
        End Sub


        ''' <summary>
        ''' This method handles the SelectedIndexChanged for Make 
        ''' </summary>
        Protected Overrides Sub Make_SelectedIndexChanged(ByVal sender As Object, ByVal e As EventArgs)
            Model.Enabled = True

            ' Model DropDownList will display 100 items.
            ' You can set the number of items displayed in the DropDownList.
            Me.PopulateModelDropDownList(Nothing, 10000)
        End Sub

        ''' <summary>
        ''' This method handles the SelectedIndexChanged for Model 
        ''' </summary>
        Protected Overrides Sub Model_SelectedIndexChanged(ByVal sender As Object, ByVal e As EventArgs)
            VehicleTypeId.Enabled = True

            ' Model DropDownList will display 100 items.
            ' You can set the number of items displayed in the DropDownList.
            Me.PopulateVehicleTypeIdDropDownList(Nothing, 10000)
        End Sub


        ' Fill the Make list.
        Protected Overrides Sub PopulateMakeDropDownList( _
                ByVal selectedValue As String, _
                ByVal maxItems As Integer)

            'Setup the WHERE clause.
            Dim wc As WhereClause = CreateWhereClause_MakeDropDownList()
            Dim orderBy As OrderBy = New OrderBy(False, True)
            orderBy.Add(VehicleTypeTable.Make, OrderByItem.OrderDir.Asc)

            Me.Make.Items.Clear()
            Dim rec As VehicleTypeRecord
            For Each rec In VehicleTypeTable.GetRecords(wc, orderBy, 0, maxItems)
                ' Create the item and add to the list.
                Dim item As ListItem = New ListItem(rec.Make, rec.Make)

                ' If the item is already in the list, do not add it.
                If Not Me.Make.Items.Contains(item) Then
                    Me.Make.Items.Add(item)
                End If
            Next

            ' Setup the selected item.
            If Not selectedValue Is Nothing AndAlso _
                selectedValue.Trim <> "" AndAlso _
                Not SetSelectedValue(Me.Make, selectedValue) AndAlso _
                Not MiscUtils.SetSelectedValue(Me.Make, OwnerVehicleTable.VehicleTypeId.Format(selectedValue)) Then
                Dim fvalue As String = OwnerVehicleTable.VehicleTypeId.Format(selectedValue)
                Dim item As ListItem = New ListItem(fvalue, selectedValue)
                item.Selected = True
                Me.Make.Items.Insert(0, item)
            End If


            Me.Make.Items.Insert(0, New ListItem(Page.GetResourceValue("Txt:PleaseSelect", "Training1"), "--PLEASE_SELECT--"))

        End Sub

        ' Fill the Model list.
        Protected Overrides Sub PopulateModelDropDownList( _
                ByVal selectedValue As String, _
                ByVal maxItems As Integer)

            'Setup the WHERE clause.
            Dim wc As WhereClause = CreateWhereClause_ModelDropDownList()
            wc.iAND(VehicleTypeTable.Make, BaseFilter.ComparisonOperator.EqualsTo, Me.Make.SelectedValue)

            Dim orderBy As OrderBy = New OrderBy(False, True)
            orderBy.Add(VehicleTypeTable.Model, OrderByItem.OrderDir.Asc)

            Me.Model.Items.Clear()
            Dim rec As VehicleTypeRecord
            For Each rec In VehicleTypeTable.GetRecords(wc, orderBy, 0, maxItems)
                Dim item As ListItem = New ListItem(rec.Model, rec.Model)

                ' If the item is already in the list, do not add it.
                If Not Me.Make.Items.Contains(item) Then
                    Me.Make.Items.Add(item)
                End If
            Next

            ' Setup the selected item.
            If Not selectedValue Is Nothing AndAlso _
                selectedValue.Trim <> "" AndAlso _
                Not SetSelectedValue(Me.Model, selectedValue) AndAlso _
                Not MiscUtils.SetSelectedValue(Me.Model, OwnerVehicleTable.VehicleTypeId.Format(selectedValue)) Then
                Dim fvalue As String = OwnerVehicleTable.VehicleTypeId.Format(selectedValue)
                Dim item As ListItem = New ListItem(fvalue, selectedValue)
                item.Selected = True
                Me.Model.Items.Insert(0, item)
            End If


            Me.Model.Items.Insert(0, New ListItem(Page.GetResourceValue("Txt:PleaseSelect", "Training1"), "--PLEASE_SELECT--"))

        End Sub

        ' Fill the VehicleTypeId list.
        Protected Overrides Sub PopulateVehicleTypeIdDropDownList( _
                ByVal selectedValue As String, _
                ByVal maxItems As Integer)

            'Setup the WHERE clause.
            Dim wc As WhereClause = CreateWhereClause_VehicleTypeIdDropDownList()
            wc.iAND(VehicleTypeTable.Make, BaseFilter.ComparisonOperator.EqualsTo, Me.Make.SelectedValue)
            wc.iAND(VehicleTypeTable.Model, BaseFilter.ComparisonOperator.EqualsTo, Me.Model.SelectedValue)

            Dim orderBy As OrderBy = New OrderBy(False, True)
            orderBy.Add(VehicleTypeTable.Make, OrderByItem.OrderDir.Asc)

            Me.VehicleTypeId.Items.Clear()
            Dim rec As VehicleTypeRecord
            For Each rec In VehicleTypeTable.GetRecords(wc, orderBy, 0, maxItems)
                ' In this list item, we use the Id as the Value.
                Dim item As ListItem = New ListItem(rec.Year, rec.Id0.ToString)

                ' If the item is already in the list, do not add it.
                If Not Me.Make.Items.Contains(item) Then
                    Me.Make.Items.Add(item)
                End If
            Next


            ' Setup the selected item.
            If Not selectedValue Is Nothing AndAlso _
                selectedValue.Trim <> "" AndAlso _
                Not SetSelectedValue(Me.VehicleTypeId, selectedValue) AndAlso _
                Not MiscUtils.SetSelectedValue(Me.VehicleTypeId, OwnerVehicleTable.VehicleTypeId.Format(selectedValue)) Then
                Dim fvalue As String = OwnerVehicleTable.VehicleTypeId.Format(selectedValue)
                Dim item As ListItem = New ListItem(fvalue, selectedValue)
                item.Selected = True
                Me.VehicleTypeId.Items.Insert(0, item)
            End If


            Me.VehicleTypeId.Items.Insert(0, New ListItem(Page.GetResourceValue("Txt:PleaseSelect", "Training1"), "--PLEASE_SELECT--"))

        End Sub

#End Region
    End Class
#End Region

  

#Region "Section 2: Do not modify this section."
    
    
' Base class for the OwnerVehicleTableControlRow control on the EditOwnerPage page.
' Do not modify this class. Instead override any method in OwnerVehicleTableControlRow.
Public Class BaseOwnerVehicleTableControlRow
        Inherits Training1.UI.BaseApplicationRecordControl

        '  To customize, override this method in OwnerVehicleTableControlRow.
      Protected Overridable Sub Control_Init(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Init

      
      
            ' Register the event handlers.
        
              AddHandler Me.OwnerVehicleRowDeleteButton.Click, AddressOf OwnerVehicleRowDeleteButton_Click
              AddHandler Me.OwnerVehicleRowEditButton.Click, AddressOf OwnerVehicleRowEditButton_Click
              AddHandler Me.OwnerVehicleRowViewButton.Click, AddressOf OwnerVehicleRowViewButton_Click
              AddHandler Me.Make.SelectedIndexChanged, AddressOf Make_SelectedIndexChanged
            
              AddHandler Me.Model.SelectedIndexChanged, AddressOf Model_SelectedIndexChanged
            
              AddHandler Me.VehicleTypeId.SelectedIndexChanged, AddressOf VehicleTypeId_SelectedIndexChanged
            
        End Sub

        '  To customize, override this method in OwnerVehicleTableControlRow.
        Protected Overridable Sub Control_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        
                ' Show confirmation message on Click
                Me.OwnerVehicleRowDeleteButton.Attributes.Add("onClick", "return (confirm('" & (CType(Me.Page,BaseApplicationPage)).GetResourceValue("DeleteRecordConfirm", "Training1") & "'));")
        End Sub

        ' Read data from database.  To customize, override this method in OwnerVehicleTableControlRow.
        Public Overridable Sub LoadData()        
        
            If Not Me.RecordUniqueId Is Nothing AndAlso Me.RecordUniqueId.Trim <> "" Then
                Me.DataSource = OwnerVehicleTable.GetRecord(Me.RecordUniqueId, True)
                Return
            End If
        
            ' Since this is a row in the table, the data for this row is loaded by the 
            ' LoadData method of the BaseOwnerVehicleTableControl when the data for the entire
            ' table is loaded.
            Me.DataSource = New OwnerVehicleRecord()
          
        End Sub

        ' Populate the UI controls using the DataSource.  To customize, override this method in OwnerVehicleTableControlRow.
        Public Overrides Sub DataBind()

            MyBase.DataBind()

            ' Make sure that the DataSource is initialized.
            If Me.DataSource Is Nothing Then
                Return
            End If
        
      
            ' For each field, check to see if a value is specified.  If a value is specified,
            ' then format the value for display.  If no value is specified, use the default value (formatted).

        
            If Me.DataSource.VehicleTypeIdSpecified Then
                Me.PopulateMakeDropDownList(Me.DataSource.VehicleTypeId.ToString(), 100)
            Else
                If Not Me.DataSource.IsCreated Then
                    Me.PopulateMakeDropDownList(OwnerVehicleTable.VehicleTypeId.DefaultValue, 100)
                Else
                    Me.PopulateMakeDropDownList(Nothing, 100)
                End If
            End If
                
            If Me.DataSource.VehicleTypeIdSpecified Then
                Me.PopulateModelDropDownList(Me.DataSource.VehicleTypeId.ToString(), 100)
            Else
                If Not Me.DataSource.IsCreated Then
                    Me.PopulateModelDropDownList(OwnerVehicleTable.VehicleTypeId.DefaultValue, 100)
                Else
                    Me.PopulateModelDropDownList(Nothing, 100)
                End If
            End If
                
            If Me.DataSource.VehicleTypeIdSpecified Then
                Me.PopulateVehicleTypeIdDropDownList(Me.DataSource.VehicleTypeId.ToString(), 10000)
            Else
                If Not Me.DataSource.IsCreated Then
                    Me.PopulateVehicleTypeIdDropDownList(OwnerVehicleTable.VehicleTypeId.DefaultValue, 10000)
                Else
                    Me.PopulateVehicleTypeIdDropDownList(Nothing, 10000)
                End If
            End If
                
            Me.IsNewRecord = True
            If Me.DataSource.IsCreated Then
                Me.IsNewRecord = False
        
                Me.RecordUniqueId = Me.DataSource.GetID.ToXmlString()
            End If

            

            ' Load data for each record and table UI control.
            ' Ordering is important because child controls get 
            ' their parent ids from their parent UI controls.
            
      End Sub


      
        
        ' To customize, override this method in OwnerVehicleTableControlRow.
        Public Overridable Sub SaveData()

            ' 1. Load the existing record from the database. Since we save the entire record, this ensures 
            ' that fields that are not displayed also properly initialized.
            Me.LoadData()
        
            ' Owner in OwnerRecordControl is One To Many to OwnerVehicleTableControl.
                    
            ' Setup the parent id in the record.
            Dim recOwnerRecordControl As OwnerRecordControl = DirectCast(Me.Page.FindControlRecursively("OwnerRecordControl"), OwnerRecordControl)
            If Not recOwnerRecordControl Is Nothing AndAlso recOwnerRecordControl.DataSource Is Nothing Then
                ' Load the record if it is not loaded yet.
                recOwnerRecordControl.LoadData()
            End If
            If recOwnerRecordControl Is Nothing OrElse recOwnerRecordControl.DataSource Is Nothing Then
                ' Get the error message from the application resource file.
                Throw New Exception(Page.GetResourceValue("Err:NoParentRecId", "Training1"))
            End If
                    
            Me.DataSource.OwnerId = recOwnerRecordControl.DataSource.Id0
            ' 2. Validate the data.  Override in OwnerVehicleTableControlRow to add custom validation.
            Me.Validate()

            ' 3. Set the values in the record with data from UI controls.  Override in OwnerVehicleTableControlRow to set additional fields.
            Me.GetUIData()

            ' 4. Save in the database.
            ' We should not save the record if the data did not change. This
            ' will save a database hit and avoid triggering any database triggers.
            If Me.DataSource.IsAnyValueChanged Then
                ' Save record to database but do not commit.
                ' Auto generated ids are available after saving for use by child (dependent) records.
                Me.DataSource.Save()
              
                DirectCast(GetParentControlObject(Me, "OwnerVehicleTableControl"), OwnerVehicleTableControl).DataChanged = True
                DirectCast(GetParentControlObject(Me, "OwnerVehicleTableControl"), OwnerVehicleTableControl).ResetData = True
            End If
            Me.DataChanged = True
            Me.ResetData = True
            ' Reseting of Me.IsNewRecord is moved to Save button's click even handler.
            ' Me.IsNewRecord() = False
            
        End Sub

        ' To customize, override this method in OwnerVehicleTableControlRow.
        Public Overridable Sub GetUIData()
            
            Me.DataSource.Parse(GetValueSelectedPageRequest(Me.Make), OwnerVehicleTable.VehicleTypeId)
                  
            Me.DataSource.Parse(GetValueSelectedPageRequest(Me.Model), OwnerVehicleTable.VehicleTypeId)
                  
            Me.DataSource.Parse(GetValueSelectedPageRequest(Me.VehicleTypeId), OwnerVehicleTable.VehicleTypeId)
                  
        End Sub

        
      
        ' To customize, override this method in OwnerVehicleTableControlRow.
        Public Overridable Function CreateWhereClause() As WhereClause
        
            Return Nothing
          
        End Function
        

        ' To customize, override this method in OwnerVehicleTableControlRow.
        Public Overridable Sub Validate() 
            ' Initially empty.  Override to add custom validation.
        End Sub

        Public Overridable Sub Delete()
        
            If Me.IsNewRecord() Then
                Return
            End If

            Dim pk As KeyValue = KeyValue.XmlToKey(Me.RecordUniqueId)
            OwnerVehicleTable.DeleteRecord(pk)

          
            DirectCast(GetParentControlObject(Me, "OwnerVehicleTableControl"), OwnerVehicleTableControl).DataChanged = True
            DirectCast(GetParentControlObject(Me, "OwnerVehicleTableControl"), OwnerVehicleTableControl).ResetData = True
        End Sub

        Private Sub Control_PreRender(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.PreRender
            Try
                DbUtils.StartTransaction()

                If Not Me.Page.ErrorOnPage AndAlso (Me.Page.IsPageRefresh OrElse Me.DataChanged OrElse Me.ResetData) Then
                    Me.LoadData()
                    Me.DataBind()
                End If

            Catch ex As Exception
                Utils.MiscUtils.RegisterJScriptAlert(Me, "BUTTON_CLICK_MESSAGE", ex.Message)
            Finally
                DbUtils.EndTransaction()
            End Try
        End Sub
        
        

        Protected Overrides Sub LoadViewState(ByVal savedState As Object)
            MyBase.LoadViewState(savedState)
            Dim isNewRecord As String = CType(ViewState("IsNewRecord"), String)
            If Not isNewRecord Is Nothing AndAlso isNewRecord.Trim <> "" Then
                Me.IsNewRecord = Boolean.Parse(isNewRecord)
            End If
            
            Dim myCheckSum As String = CType(ViewState("CheckSum"), String)
            If Not myCheckSum Is Nothing AndAlso myCheckSum.Trim <> "" Then
                Me.CheckSum = myCheckSum
            End If
            
        End Sub

        Protected Overrides Function SaveViewState() As Object
            ViewState("IsNewRecord") = Me.IsNewRecord.ToString()
            ViewState("CheckSum") = Me.CheckSum
            
            Return MyBase.SaveViewState()
        End Function
        
        
        Public Overridable Function CreateWhereClause_MakeDropDownList() As WhereClause
            Return New WhereClause()
        End Function
                
        Public Overridable Function CreateWhereClause_ModelDropDownList() As WhereClause
            Return New WhereClause()
        End Function
                
        Public Overridable Function CreateWhereClause_VehicleTypeIdDropDownList() As WhereClause
            Return New WhereClause()
        End Function
                
        ' Fill the Make list.
        Protected Overridable Sub PopulateMakeDropDownList( _
                ByVal selectedValue As String, _
                ByVal maxItems As Integer)
                  
            'Setup the WHERE clause.
            Dim wc As WhereClause = CreateWhereClause_MakeDropDownList()
            Dim orderBy As OrderBy = New OrderBy(False, True)
            orderBy.Add(VehicleTypeTable.Make, OrderByItem.OrderDir.Asc)

            Me.Make.Items.Clear()
            Dim itemValue As VehicleTypeRecord
            For Each itemValue In VehicleTypeTable.GetRecords(wc, orderBy, 0, maxItems)
                ' Create the item and add to the list.
                Dim cvalue As String = Nothing
                Dim fvalue As String = Nothing
                If itemValue.Id0Specified Then
                    cvalue = itemValue.Id0.ToString()
                    fvalue = itemValue.Format(VehicleTypeTable.Make)
                End If

                Dim item As ListItem = New ListItem(fvalue, cvalue)
                Me.Make.Items.Add(item)
            Next
                    
            ' Setup the selected item.
            If Not selectedValue Is Nothing AndAlso _
                selectedValue.Trim <> "" AndAlso _
                Not SetSelectedValue(Me.Make, selectedValue) AndAlso _
                Not MiscUtils.SetSelectedValue(Me.Make, OwnerVehicleTable.VehicleTypeId.Format(selectedValue))Then
                Dim fvalue As String = OwnerVehicleTable.VehicleTypeId.Format(selectedValue)
                Dim item As ListItem = New ListItem(fvalue, selectedValue)
                item.Selected = True
                Me.Make.Items.Insert(0, item)
            End If

                  
            Me.Make.Items.Insert(0, New ListItem(Page.GetResourceValue("Txt:PleaseSelect", "Training1"), "--PLEASE_SELECT--"))
                  
        End Sub
                
        ' Fill the Model list.
        Protected Overridable Sub PopulateModelDropDownList( _
                ByVal selectedValue As String, _
                ByVal maxItems As Integer)
                  
            'Setup the WHERE clause.
            Dim wc As WhereClause = CreateWhereClause_ModelDropDownList()
            Dim orderBy As OrderBy = New OrderBy(False, True)
            orderBy.Add(VehicleTypeTable.Make, OrderByItem.OrderDir.Asc)

            Me.Model.Items.Clear()
            Dim itemValue As VehicleTypeRecord
            For Each itemValue In VehicleTypeTable.GetRecords(wc, orderBy, 0, maxItems)
                ' Create the item and add to the list.
                Dim cvalue As String = Nothing
                Dim fvalue As String = Nothing
                If itemValue.Id0Specified Then
                    cvalue = itemValue.Id0.ToString()
                    fvalue = itemValue.Format(VehicleTypeTable.Make)
                End If

                Dim item As ListItem = New ListItem(fvalue, cvalue)
                Me.Model.Items.Add(item)
            Next
                    
            ' Setup the selected item.
            If Not selectedValue Is Nothing AndAlso _
                selectedValue.Trim <> "" AndAlso _
                Not SetSelectedValue(Me.Model, selectedValue) AndAlso _
                Not MiscUtils.SetSelectedValue(Me.Model, OwnerVehicleTable.VehicleTypeId.Format(selectedValue))Then
                Dim fvalue As String = OwnerVehicleTable.VehicleTypeId.Format(selectedValue)
                Dim item As ListItem = New ListItem(fvalue, selectedValue)
                item.Selected = True
                Me.Model.Items.Insert(0, item)
            End If

                  
            Me.Model.Items.Insert(0, New ListItem(Page.GetResourceValue("Txt:PleaseSelect", "Training1"), "--PLEASE_SELECT--"))
                  
        End Sub
                
        ' Fill the VehicleTypeId list.
        Protected Overridable Sub PopulateVehicleTypeIdDropDownList( _
                ByVal selectedValue As String, _
                ByVal maxItems As Integer)
                  
            'Setup the WHERE clause.
            Dim wc As WhereClause = CreateWhereClause_VehicleTypeIdDropDownList()
            Dim orderBy As OrderBy = New OrderBy(False, True)
            orderBy.Add(VehicleTypeTable.Make, OrderByItem.OrderDir.Asc)

            Me.VehicleTypeId.Items.Clear()
            Dim itemValue As VehicleTypeRecord
            For Each itemValue In VehicleTypeTable.GetRecords(wc, orderBy, 0, maxItems)
                ' Create the item and add to the list.
                Dim cvalue As String = Nothing
                Dim fvalue As String = Nothing
                If itemValue.Id0Specified Then
                    cvalue = itemValue.Id0.ToString()
                    fvalue = itemValue.Format(VehicleTypeTable.Make)
                End If

                Dim item As ListItem = New ListItem(fvalue, cvalue)
                Me.VehicleTypeId.Items.Add(item)
            Next
                    
            ' Setup the selected item.
            If Not selectedValue Is Nothing AndAlso _
                selectedValue.Trim <> "" AndAlso _
                Not SetSelectedValue(Me.VehicleTypeId, selectedValue) AndAlso _
                Not MiscUtils.SetSelectedValue(Me.VehicleTypeId, OwnerVehicleTable.VehicleTypeId.Format(selectedValue))Then
                Dim fvalue As String = OwnerVehicleTable.VehicleTypeId.Format(selectedValue)
                Dim item As ListItem = New ListItem(fvalue, selectedValue)
                item.Selected = True
                Me.VehicleTypeId.Items.Insert(0, item)
            End If

                  
            Me.VehicleTypeId.Items.Insert(0, New ListItem(Page.GetResourceValue("Txt:PleaseSelect", "Training1"), "--PLEASE_SELECT--"))
                  
        End Sub
                
        ' event handler for ImageButton
        Public Overridable Sub OwnerVehicleRowDeleteButton_Click(ByVal sender As Object, ByVal args As ImageClickEventArgs)
        
            Try
                DbUtils.StartTransaction
                
            If(Not Me.Page.IsPageRefresh) Then
        
                Dim tc As OwnerVehicleTableControl = DirectCast(GetParentControlObject(Me, "OwnerVehicleTableControl"), OwnerVehicleTableControl)
                If Not (IsNothing(tc)) Then
                    If Not Me.IsNewRecord Then
                        tc.AddToDeletedRecordIds(DirectCast(Me, OwnerVehicleTableControlRow))
                    End If
                    Me.Visible = False
                End If
              
            End If
                Me.Page.CommitTransaction(sender)
          
            Catch ex As Exception
                Me.Page.RollBackTransaction(sender)
                Me.Page.ErrorOnPage = True
    
                Utils.MiscUtils.RegisterJScriptAlert(Me, "BUTTON_CLICK_MESSAGE", ex.Message)
          
            Finally
                DbUtils.EndTransaction
            End Try
                  
        End Sub
            
        ' event handler for ImageButton
        Public Overridable Sub OwnerVehicleRowEditButton_Click(ByVal sender As Object, ByVal args As ImageClickEventArgs)
        
            Dim url As String = "../Shared/ConfigureEditRecord.aspx"
            Dim shouldRedirect As Boolean = True
            Dim TargetKey As String = Nothing
            Dim DFKA As String = Nothing
            Dim id As String = Nothing
            Dim value As String = Nothing
            Try
                DbUtils.StartTransaction
                
            url = Me.ModifyRedirectUrl(url, "",False)
            url = Me.Page.ModifyRedirectUrl(url, "",False)
                    Me.Page.CommitTransaction(sender)
          
            Catch ex As Exception
                Me.Page.RollBackTransaction(sender)
                shouldRedirect = False
                Me.Page.ErrorOnPage = True
    
                Utils.MiscUtils.RegisterJScriptAlert(Me, "BUTTON_CLICK_MESSAGE", ex.Message)
          
            Finally
                DbUtils.EndTransaction
            End Try
            If shouldRedirect Then
                Me.Page.ShouldSaveControlsToSession = True
                Me.Page.Response.Redirect(url)
            ElseIf Not TargetKey Is Nothing AndAlso _
                        Not shouldRedirect Then
            Me.Page.ShouldSaveControlsToSession = True
            Me.Page.CloseWindow(True)
        
            End If              
        End Sub
            
        ' event handler for ImageButton
        Public Overridable Sub OwnerVehicleRowViewButton_Click(ByVal sender As Object, ByVal args As ImageClickEventArgs)
        
            Dim url As String = "../Shared/ConfigureViewRecord.aspx"
            Dim shouldRedirect As Boolean = True
            Dim TargetKey As String = Nothing
            Dim DFKA As String = Nothing
            Dim id As String = Nothing
            Dim value As String = Nothing
            Try
                DbUtils.StartTransaction
                
            url = Me.ModifyRedirectUrl(url, "",False)
            url = Me.Page.ModifyRedirectUrl(url, "",False)
                    Me.Page.CommitTransaction(sender)
          
            Catch ex As Exception
                Me.Page.RollBackTransaction(sender)
                shouldRedirect = False
                Me.Page.ErrorOnPage = True
    
                Utils.MiscUtils.RegisterJScriptAlert(Me, "BUTTON_CLICK_MESSAGE", ex.Message)
          
            Finally
                DbUtils.EndTransaction
            End Try
            If shouldRedirect Then
                Me.Page.ShouldSaveControlsToSession = True
                Me.Page.Response.Redirect(url)
            ElseIf Not TargetKey Is Nothing AndAlso _
                        Not shouldRedirect Then
            Me.Page.ShouldSaveControlsToSession = True
            Me.Page.CloseWindow(True)
        
            End If              
        End Sub
            
              Protected Overridable Sub Make_SelectedIndexChanged(ByVal sender As Object, ByVal args As EventArgs)
              Dim selectedValue As String = MiscUtils.GetValueSelectedPageRequest(Me.Make)
              If Not selectedValue Is Nothing AndAlso _
              selectedValue.Trim <> "" AndAlso _
              Not SetSelectedValue(Me.Make, selectedValue) AndAlso _
              Not MiscUtils.SetSelectedValue(Me.Make, OwnerVehicleTable.VehicleTypeId.Format(selectedValue)) Then
              Dim fvalue As String = OwnerVehicleTable.VehicleTypeId.Format(selectedValue)
              Dim item As ListItem = New ListItem(fvalue, selectedValue)
              item.Selected = True
              Me.Make.Items.Insert(0, item)
              End If
              End Sub
            
              Protected Overridable Sub Model_SelectedIndexChanged(ByVal sender As Object, ByVal args As EventArgs)
              Dim selectedValue As String = MiscUtils.GetValueSelectedPageRequest(Me.Model)
              If Not selectedValue Is Nothing AndAlso _
              selectedValue.Trim <> "" AndAlso _
              Not SetSelectedValue(Me.Model, selectedValue) AndAlso _
              Not MiscUtils.SetSelectedValue(Me.Model, OwnerVehicleTable.VehicleTypeId.Format(selectedValue)) Then
              Dim fvalue As String = OwnerVehicleTable.VehicleTypeId.Format(selectedValue)
              Dim item As ListItem = New ListItem(fvalue, selectedValue)
              item.Selected = True
              Me.Model.Items.Insert(0, item)
              End If
              End Sub
            
              Protected Overridable Sub VehicleTypeId_SelectedIndexChanged(ByVal sender As Object, ByVal args As EventArgs)
              Dim selectedValue As String = MiscUtils.GetValueSelectedPageRequest(Me.VehicleTypeId)
              If Not selectedValue Is Nothing AndAlso _
              selectedValue.Trim <> "" AndAlso _
              Not SetSelectedValue(Me.VehicleTypeId, selectedValue) AndAlso _
              Not MiscUtils.SetSelectedValue(Me.VehicleTypeId, OwnerVehicleTable.VehicleTypeId.Format(selectedValue)) Then
              Dim fvalue As String = OwnerVehicleTable.VehicleTypeId.Format(selectedValue)
              Dim item As ListItem = New ListItem(fvalue, selectedValue)
              item.Selected = True
              Me.VehicleTypeId.Items.Insert(0, item)
              End If
              End Sub
            
      
        Private _IsNewRecord As Boolean = True
        Public Overridable Property IsNewRecord() As Boolean
            Get
                Return Me._IsNewRecord
            End Get
            Set(ByVal value As Boolean)
                Me._IsNewRecord = value
            End Set
        End Property

        Private _DataChanged As Boolean = False
        Public Overridable Property DataChanged() As Boolean
            Get
                Return Me._DataChanged
            End Get
            Set(ByVal Value As Boolean)
                Me._DataChanged = Value
            End Set
        End Property

        Private _ResetData As Boolean = False
        Public Overridable Property ResetData() As Boolean
            Get
                Return Me._ResetData
            End Get
            Set(ByVal Value As Boolean)
                Me._ResetData = Value
            End Set
        End Property
        
        Public Property RecordUniqueId() As String
            Get
                Return CType(Me.ViewState("BaseOwnerVehicleTableControlRow_Rec"), String)
            End Get
            Set(ByVal value As String)
                Me.ViewState("BaseOwnerVehicleTableControlRow_Rec") = value
            End Set
        End Property
        
        Private _DataSource As OwnerVehicleRecord
        Public Property DataSource() As OwnerVehicleRecord
            Get
                Return Me._DataSource
            End Get
            Set(ByVal value As OwnerVehicleRecord)
                Me._DataSource = value
            End Set
        End Property

        Private _checkSum As String
        Public Overridable Property CheckSum() As String
            Get
                Return Me._checkSum
            End Get
            Set(ByVal value As String)
                Me._checkSum = value
            End Set
        End Property
        
        Private _TotalPages As Integer
        Public Property TotalPages() As Integer
            Get
                Return Me._TotalPages
            End Get
            Set(ByVal value As Integer)
                Me._TotalPages = value
            End Set
        End Property
        
        Private _PageIndex As Integer
        Public Property PageIndex() As Integer
            Get
                ' Return the PageIndex
                Return Me._PageIndex
            End Get
            Set(ByVal value As Integer)
                Me._PageIndex = value
            End Set
        End Property
        
        Private _DisplayLastPage As Boolean
        Public Property DisplayLastPage() As Boolean
            Get
                Return Me._DisplayLastPage
            End Get
            Set(ByVal value As Boolean)
                Me._DisplayLastPage = value
            End Set
        End Property
        
        

#Region "Helper Properties"
        
        Public ReadOnly Property Make() As System.Web.UI.WebControls.DropDownList
            Get
                Return CType(BaseClasses.Utils.MiscUtils.FindControlRecursively(Me, "Make"), System.Web.UI.WebControls.DropDownList)
            End Get
        End Property
            
        Public ReadOnly Property Model() As System.Web.UI.WebControls.DropDownList
            Get
                Return CType(BaseClasses.Utils.MiscUtils.FindControlRecursively(Me, "Model"), System.Web.UI.WebControls.DropDownList)
            End Get
        End Property
            
        Public ReadOnly Property OwnerVehicleRecordRowSelection() As System.Web.UI.WebControls.CheckBox
            Get
                Return CType(BaseClasses.Utils.MiscUtils.FindControlRecursively(Me, "OwnerVehicleRecordRowSelection"), System.Web.UI.WebControls.CheckBox)
            End Get
        End Property
        
        Public ReadOnly Property OwnerVehicleRowDeleteButton() As System.Web.UI.WebControls.ImageButton
            Get
                Return CType(BaseClasses.Utils.MiscUtils.FindControlRecursively(Me, "OwnerVehicleRowDeleteButton"), System.Web.UI.WebControls.ImageButton)
            End Get
        End Property
        
        Public ReadOnly Property OwnerVehicleRowEditButton() As System.Web.UI.WebControls.ImageButton
            Get
                Return CType(BaseClasses.Utils.MiscUtils.FindControlRecursively(Me, "OwnerVehicleRowEditButton"), System.Web.UI.WebControls.ImageButton)
            End Get
        End Property
        
        Public ReadOnly Property OwnerVehicleRowViewButton() As System.Web.UI.WebControls.ImageButton
            Get
                Return CType(BaseClasses.Utils.MiscUtils.FindControlRecursively(Me, "OwnerVehicleRowViewButton"), System.Web.UI.WebControls.ImageButton)
            End Get
        End Property
        
        Public ReadOnly Property VehicleTypeId() As System.Web.UI.WebControls.DropDownList
            Get
                Return CType(BaseClasses.Utils.MiscUtils.FindControlRecursively(Me, "VehicleTypeId"), System.Web.UI.WebControls.DropDownList)
            End Get
        End Property
            
#End Region

#Region "Helper Functions"

        Public Overrides Overloads Function ModifyRedirectUrl(ByVal url As String, ByVal arg As String, ByVal bEncrypt As Boolean) As String
            Dim rec As OwnerVehicleRecord = Nothing
            
            Try
                rec = Me.GetRecord()
            Catch ex As Exception
                ' Do nothing
            End Try

            If rec Is Nothing AndAlso url.IndexOf("{") >= 0 Then
                ' Localization.
                
            Throw New Exception(Page.GetResourceValue("Err:RecDataSrcNotInitialized", "Training1"))
                    
            End If
            Return ModifyRedirectUrl(url, arg, rec, bEncrypt)
        End Function

        Public Function GetRecord() As OwnerVehicleRecord
            If Not Me.DataSource Is Nothing Then
                Return Me.DataSource
            End If
            
            If Not Me.RecordUniqueId Is Nothing Then
                Return OwnerVehicleTable.GetRecord(Me.RecordUniqueId, True)
            End If
            
            ' Localization.
            
            Throw New Exception(Page.GetResourceValue("Err:RetrieveRec", "Training1"))
                
        End Function

        Public Shadows ReadOnly Property Page() As BaseApplicationPage
            Get
                Return DirectCast(MyBase.Page, BaseApplicationPage)
            End Get
        End Property

#End Region

End Class

  

' Base class for the OwnerVehicleTableControl control on the EditOwnerPage page.
' Do not modify this class. Instead override any method in OwnerVehicleTableControl.
Public Class BaseOwnerVehicleTableControl
        Inherits Training1.UI.BaseApplicationTableControl

        Protected Overridable Sub Control_Init(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Init

            ' Setup the pagination events.
        
              AddHandler Me.OwnerVehiclePagination.FirstPage.Click, AddressOf OwnerVehiclePagination_FirstPage_Click
              AddHandler Me.OwnerVehiclePagination.LastPage.Click, AddressOf OwnerVehiclePagination_LastPage_Click
              AddHandler Me.OwnerVehiclePagination.NextPage.Click, AddressOf OwnerVehiclePagination_NextPage_Click
              AddHandler Me.OwnerVehiclePagination.PageSizeButton.Click, AddressOf OwnerVehiclePagination_PageSizeButton_Click
            
              AddHandler Me.OwnerVehiclePagination.PreviousPage.Click, AddressOf OwnerVehiclePagination_PreviousPage_Click

            ' Setup the sorting events.
        
              AddHandler Me.VehicleTypeIdLabel1.Click, AddressOf VehicleTypeIdLabel1_Click
            

            ' Setup the button events.
        
              AddHandler Me.OwnerVehicleAddButton.Click, AddressOf OwnerVehicleAddButton_Click
              AddHandler Me.OwnerVehicleDeleteButton.Click, AddressOf OwnerVehicleDeleteButton_Click
              AddHandler Me.OwnerVehicleEditButton.Click, AddressOf OwnerVehicleEditButton_Click
              AddHandler Me.OwnerVehicleRefreshButton.Click, AddressOf OwnerVehicleRefreshButton_Click
              AddHandler Me.OwnerVehicleResetButton.Click, AddressOf OwnerVehicleResetButton_Click

            ' Setup the filter and search events.
        

            ' Control Initializations.
            ' Initialize the table's current sort order.
            If Me.InSession(Me, "Order_By") Then
                Me.CurrentSortOrder = OrderBy.FromXmlString(Me.GetFromSession(Me, "Order_By", Nothing))
            Else
                Me.CurrentSortOrder = New OrderBy(True, True)
        
            End If

            ' Setup default pagination settings.
        
            Me.PageSize = CInt(Me.GetFromSession(Me, "Page_Size", "10"))
            Me.PageIndex = CInt(Me.GetFromSession(Me, "Page_Index", "0"))
            Me.ClearControlsFromSession()
        End Sub

        Protected Overridable Sub Control_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        
            SaveControlsToSession_Ajax()
        
                ' Show confirmation message on Click
                Me.OwnerVehicleDeleteButton.Attributes.Add("onClick", "return (confirm('" & (CType(Me.Page,BaseApplicationPage)).GetResourceValue("DeleteConfirm", "Training1") & "'));")
        End Sub

        ' Read data from database. Returns an array of records that can be assigned
        ' to the DataSource table control property.
        Public Overridable Sub LoadData()
            Try
            
                ' The WHERE clause will be empty when displaying all records in table.
                Dim wc As WhereClause = CreateWhereClause()
                If Not wc Is Nothing AndAlso Not wc.RunQuery Then
                    ' Initialize an empty array of records
                    Dim alist As New ArrayList(0)
                    Me.DataSource = DirectCast(alist.ToArray(GetType(OwnerVehicleRecord)), OwnerVehicleRecord())
                    ' Add records to the list if needed.
                    Me.AddNewRecords()
                    Return
                End If

                Dim orderBy As OrderBy = CreateOrderBy()

                ' Get the pagesize from the pagesize control.
                Me.GetPageSize()

                ' Get the total number of records to be displayed.
                Me.TotalRecords = OwnerVehicleTable.GetRecordCount(wc)

                ' Go to the last page.
                If Me.TotalPages <= 0 OrElse Me.PageIndex < 0 Then
                    Me.PageIndex = 0
                ElseIf Me.DisplayLastPage OrElse Me.PageIndex >= Me.TotalPages Then
                    Me.PageIndex = Me.TotalPages - 1
                End If

                ' Retrieve the records and set the table DataSource.
                ' Only PageSize records are fetched starting at PageIndex (zero based).
                If Me.TotalRecords <= 0 Then
                    ' Initialize an empty array of records
                    Dim alist As New ArrayList(0)
                    Me.DataSource = DirectCast(alist.ToArray(GetType(OwnerVehicleRecord)), OwnerVehicleRecord())
                ElseIf Me.AddNewRecord > 0 Then
                    ' Get the records from the posted data
                    Dim postdata As New ArrayList
                    For Each rc As OwnerVehicleTableControlRow In Me.GetRecordControls()
                        If Not rc.IsNewRecord Then
                            rc.DataSource = rc.GetRecord()
                            rc.GetUIData()
                            postdata.Add(rc.DataSource)
                        End If
                    Next
                    Me.DataSource = DirectCast(postdata.ToArray(GetType(OwnerVehicleRecord)), OwnerVehicleRecord())
                Else
                    ' Get the records from the database
                    Me.DataSource = OwnerVehicleTable.GetRecords(wc, orderBy, Me.PageIndex, Me.PageSize)
                End If
                ' Add records to the list.
                Me.AddNewRecords()

                ' Initialize the page and grand totals. now
            
            Catch ex As Exception
                Throw ex
            End Try
        End Sub

        ' Populate the UI controls.
        Public Overrides Sub DataBind()

            MyBase.DataBind()

            ' Make sure that the DataSource is initialized.
            If Me.DataSource Is Nothing Then
                Return
            End If

        
            ' Improve performance by prefetching display as records.
            Me.PreFetchForeignKeyValues()

            ' Setup the pagination controls.
            BindPaginationControls()

            ' Populate all filters data.
        

            ' Bind the repeater with the list of records to expand the UI.
            Dim rep As System.Web.UI.WebControls.Repeater = CType(Me.FindControl("OwnerVehicleTableControlRepeater"), System.Web.UI.WebControls.Repeater)
            rep.DataSource = Me.DataSource()
            rep.DataBind()

            Dim index As Integer = 0
            Dim repItem As System.Web.UI.WebControls.RepeaterItem
            For Each repItem In rep.Items
                ' Loop through all rows in the table, set its DataSource and call DataBind().
                Dim recControl As OwnerVehicleTableControlRow = DirectCast(repItem.FindControl("OwnerVehicleTableControlRow"), OwnerVehicleTableControlRow)
                recControl.DataSource = Me.DataSource(index)
                recControl.DataBind()
                recControl.Visible = Not Me.InDeletedRecordIds(recControl)
                index += 1
            Next
        End Sub

        
        Public Sub PreFetchForeignKeyValues()
            If Me.DataSource Is Nothing Then
                Return
            End If
          
            Me.Page.PregetDfkaRecords(OwnerVehicleTable.VehicleTypeId, Me.DataSource)
            Me.Page.PregetDfkaRecords(OwnerVehicleTable.VehicleTypeId, Me.DataSource)
            Me.Page.PregetDfkaRecords(OwnerVehicleTable.VehicleTypeId, Me.DataSource)
        End Sub
         

        Protected Overridable Sub BindPaginationControls()

            ' Setup the pagination controls.

            ' Bind the buttons for OwnerVehicleTableControl pagination.
        
            Me.OwnerVehiclePagination.FirstPage.Enabled = Not (Me.PageIndex = 0)
            Me.OwnerVehiclePagination.LastPage.Enabled = Not (Me.PageIndex = Me.TotalPages - 1)
            If Me.TotalPages = 0 Then
                Me.OwnerVehiclePagination.LastPage.Enabled = False
            End If
          
            Me.OwnerVehiclePagination.NextPage.Enabled = Not (Me.PageIndex = Me.TotalPages - 1)
            If Me.TotalPages = 0 Then
                Me.OwnerVehiclePagination.NextPage.Enabled = False
            End If
          
            Me.OwnerVehiclePagination.PreviousPage.Enabled = Not (Me.PageIndex = 0)

            ' Bind the pagination labels.
        
            If Me.TotalPages > 0 Then
                Me.OwnerVehiclePagination.CurrentPage.Text = (Me.PageIndex + 1).ToString()
            Else
                Me.OwnerVehiclePagination.CurrentPage.Text = "0"
            End If
            Me.OwnerVehiclePagination.PageSize.Text = Me.PageSize.ToString()
            Me.OwnerVehicleTotalItems.Text = Me.TotalRecords.ToString()
            Me.OwnerVehiclePagination.TotalItems.Text = Me.TotalRecords.ToString()
            Me.OwnerVehiclePagination.TotalPages.Text = Me.TotalPages.ToString()
        End Sub

        Public Overridable Sub SaveData()
            Dim recCtl As OwnerVehicleTableControlRow
            For Each recCtl In Me.GetRecordControls()
        
                If Me.InDeletedRecordIds(recCtl) Then
                    recCtl.Delete()
                Else
                    If recCtl.Visible Then
                        recCtl.SaveData()
                    End If
                End If
          
            Next
            
            Me.DataChanged = True
            Me.ResetData = True
        End Sub

        Public Overridable Function CreateOrderBy() As OrderBy
            Return Me.CurrentSortOrder
        End Function
        
        'This CreateWhereClause is used for loading the data.
        Public Overridable Function CreateWhereClause() As WhereClause
            OwnerVehicleTable.Instance.InnerFilter = Nothing
            Dim wc As WhereClause = New WhereClause()
            ' Compose the WHERE clause consiting of:
            ' 1. Static clause defined at design time.
            ' 2. User selected filter criteria.
            ' 3. User selected search criteria.
        
            Dim parentRecordControl As OwnerRecordControl = DirectCast(Me.Page.FindControlRecursively("OwnerRecordControl"), OwnerRecordControl)
            Dim parentRec As OwnerRecord = parentRecordControl.GetRecord()
            If parentRec Is Nothing Then
                ' Get the error message from the application resource file.
                Throw New Exception(Page.GetResourceValue("Err:ParentNotInitialized", "Training1"))
            End If
           
            If parentRec.Id0Specified Then
                wc.iAND(OwnerVehicleTable.OwnerId, BaseFilter.ComparisonOperator.EqualsTo, parentRec.Id0.ToString())
            Else
                wc.RunQuery = False
                Return wc
            End If
                
            Return wc
        End Function
        
        
        ' This CreateWhereClause is used for loading list of suggestions for Auto Type-Ahead feature.
        Public Overridable Function CreateWhereClause(ByVal searchText as String, ByVal fromSearchControl as String, ByVal AutoTypeAheadSearch as String, ByVal AutoTypeAheadWordSeparators as String) As WhereClause
            OwnerVehicleTable.Instance.InnerFilter = Nothing
            Dim wc As WhereClause = New WhereClause()
            ' Compose the WHERE clause consiting of:
            ' 1. Static clause defined at design time.
            ' 2. User selected filter criteria.
            ' 3. User selected search criteria.
            Dim appRelativeVirtualPath As String = CType(HttpContext.Current.Session("AppRelatvieVirtualPath"), String)
          
            Dim recId As String = CType(HttpContext.Current.Session()("SelectedID"), String)
            If Not IsNothing(recId) then
                If KeyValue.IsXmlKey(recId) Then
                    Dim pkValue As KeyValue = KeyValue.XmlToKey(recId)
                
                      wc.iAND(OwnerVehicleTable.OwnerId, BaseFilter.ComparisonOperator.EqualsTo, pkValue.GetColumnValue(OwnerTable.Id0).ToString())
                
                Else
                
                      wc.iAND(OwnerVehicleTable.OwnerId, BaseFilter.ComparisonOperator.EqualsTo, recId)
              
                End If
            End If
              
            ' Adds clauses if values are selected in Filter controls which are configured in the page.
          
            Return wc
        End Function
          
          
        'Formats the resultItem and adds it to the list of suggestions.
        Public Overridable Function FormatSuggestions(ByVal prefixText As String, ByVal resultItem as String, _
                                                 ByVal columnLength As Integer, ByVal AutoTypeAheadDisplayFoundText as String, _
                                                 ByVal autoTypeAheadSearch as String, ByVal AutoTypeAheadWordSeparators as String, _
                                                 ByVal resultList as ArrayList) as Boolean
            Dim index As Integer = InvariantLCase(resultItem).IndexOf(InvariantLCase(prefixText))
            Dim itemToAdd As String = ""
            Dim isFound as Boolean = False
            Dim isAdded as Boolean = False
            ' Get the index where prfixt is at the beginning of resultItem. If not found then, index of word which begins with prefixText.
            If InvariantLCase(autoTypeAheadSearch).equals("wordsstartingwithsearchstring") and not index = 0 Then
                ' Expression to find word which contains AutoTypeAheadWordSeparators followed by prefixText
                Dim regex1 As System.Text.RegularExpressions.Regex = new System.Text.RegularExpressions.Regex( AutoTypeAheadWordSeparators + prefixText, System.Text.RegularExpressions.RegexOptions.IgnoreCase)
                If regex1.IsMatch(resultItem) Then
                    index = regex1.Match(resultItem).Index
                    isFound = True
                End If
                ' If the prefixText is found immediatly after white space then starting of the word is found so don not search any further
                If not resultItem(index).ToString() = " " Then
                    ' Expression to find beginning of the word which contains AutoTypeAheadWordSeparators followed by prefixText
                    Dim regex As System.Text.RegularExpressions.Regex = new System.Text.RegularExpressions.Regex("\\S*" + AutoTypeAheadWordSeparators + prefixText, System.Text.RegularExpressions.RegexOptions.IgnoreCase)
                    If regex.IsMatch(resultItem) Then
                        index = regex.Match(resultItem).Index
                        isFound = True
                    End If
                 End If
            End If
            ' If autoTypeAheadSearch value is wordsstartingwithsearchstring then, extract the substring only if the prefixText is found at the 
            ' beginning of the resultItem (index = 0) or a word in resultItem is found starts with prefixText. 
            If index = 0 Or isFound Or InvariantLCase(autoTypeAheadSearch).Equals("anywhereinstring") then
                If InvariantLCase(AutoTypeAheadDisplayFoundText).equals("atbeginningofmatchedstring") Then
                    ' Expression to find beginning of the word which contains prefixText
                    Dim regex1 As System.Text.RegularExpressions.Regex = new System.Text.RegularExpressions.Regex("\\S*" + prefixText, System.Text.RegularExpressions.RegexOptions.IgnoreCase)
                    '  Find the beginning of the word which contains prefexText
                    If (StringUtils.InvariantLCase(autoTypeAheadSearch).Equals("anywhereinstring") AndAlso regex1.IsMatch(resultItem)) Then
                        index = regex1.Match(resultItem).Index
                        isFound = True
                    End If
                    ' Display string from the index till end of the string if sub string from index till end is less than columnLength value.
                    If Len(resultItem) - index <= columnLength Then
                        If index = 0 Then 
                            itemToAdd = resultItem 
                        Else
                            itemToAdd = "..." & resultItem.Substring(index, Len(resultItem) - index) 
                        End If
                    Else
                        If index = 0 Then
                            itemToAdd = resultItem.Substring(index, (columnLength - 3)) & "..."
                        Else
                            'Truncate the string to show only columnLength - 6 characters as begining and trailing "..." has to be appended.
                            itemToAdd = "..." & resultItem.Substring(index , columnLength - 6) & "..." 
                        End If
                    End If
                ElseIf InvariantLCase(AutoTypeAheadDisplayFoundText).equals("inmiddleofmatchedstring") Then
                    Dim subStringBeginIndex as Integer = CType(columnLength/2, Integer)
                    If Len(resultItem) <= columnLength Then
                        itemToAdd = resultItem
                    Else
                        ' Sanity check at end of the string
                        If index + Len(prefixText) = columnLength Then
                            itemToAdd =  "..." & resultItem.Substring(index-columnLength,index)
                        ElseIf Len(resultITem) - index < subStringBeginIndex Then 
                            ' Display string from the end till columnLength value if, index is closer to the end of the string.
                            itemToAdd =  "..." & resultItem.Substring(Len(resultItem)-columnLength,Len(resultItem))
                        ElseIf index <= subStringBeginIndex Then 
                            ' Sanity chet at beginning of the string
                            itemToAdd =  resultItem.Substring(0, columnLength) & "..."
                        Else
                            ' Display string containing text before the prefixText occures and text after the prefixText
                            itemToAdd =  "..." & resultItem.Substring(index - subStringBeginIndex, columnLength) & "..." 
                        End If
                    End If
                ElseIf InvariantLCase(AutoTypeAheadDisplayFoundText).equals("atendofmatchedstring") Then
                     ' Expression to find ending of the word which contains prefexText
                    Dim regex1 as System.Text.RegularExpressions.Regex = new System.Text.RegularExpressions.Regex("\s", System.Text.RegularExpressions.RegexOptions.IgnoreCase)
                    ' Find the ending of the word which contains prefexText
                    If regex1.IsMatch(resultItem, index + 1) Then
                        index = regex1.Match(resultItem, index + 1).Index
                    Else
                        ' If the word which contains prefexText is the last word in string, regex1.IsMatch returns false.
                        index = resultItem.Length
                    End If
                    If index > Len(resultItem) Then
                        index = Len(resultItem)
                    End If
                    ' If text from beginning of the string till index is less than columnLength value then, display string from the beginning till index.
                    If  index <= columnLength Then
                        if index = Len(resultItem) then   'Make decision to append "..."
                            itemToAdd = resultItem.Substring(0,index)
                        Else
                            itemToAdd = resultItem.Substring(0,index) & "..."
                        End If
                    Else
                        If index = Len(resultItem) Then
                            itemToAdd = "..." & resultItem.Substring(index - (columnLength - 3), (columnLength - 3))
                        Else
                            'Truncate the string to show only columnLength - 6 characters as begining and trailing "..." has to be appended.
                            itemToAdd = "..." & resultItem.Substring(index - (columnLength - 6), columnLength - 6) & "..." 
                        End If
                    End If
                End If
                
                ' Remove newline character from itemToAdd
                Dim prefixTextIndex As Integer = itemToAdd.IndexOf(prefixText, StringComparison.InvariantCultureIgnoreCase)
                ' If itemToAdd contains any newline after the search text then show text only till newline
                Dim regex2 As System.Text.RegularExpressions.Regex = New System.Text.RegularExpressions.Regex("(" & vbCrLf & "|" & vbLf & ")", System.Text.RegularExpressions.RegexOptions.IgnoreCase)
                Dim newLineIndexAfterPrefix As Integer = -1
                If regex2.IsMatch(itemToAdd, prefixTextIndex) Then
                    newLineIndexAfterPrefix = regex2.Match(itemToAdd, prefixTextIndex).Index
                End If
                If (newLineIndexAfterPrefix > -1) Then
                    If itemToAdd.EndsWith("...") Then
                        itemToAdd = (itemToAdd.Substring(0, newLineIndexAfterPrefix) + "...")
                    Else
                        itemToAdd = itemToAdd.Substring(0, newLineIndexAfterPrefix)
                    End If
                End If
                ' If itemToAdd contains any newline before search text then show text which comes after newline
                Dim regex3 As System.Text.RegularExpressions.Regex = New System.Text.RegularExpressions.Regex("(" & vbCrLf & "|" & vbLf & ")", (System.Text.RegularExpressions.RegexOptions.IgnoreCase Or System.Text.RegularExpressions.RegexOptions.RightToLeft))
                Dim newLineIndexBeforePrefix As Integer = -1
                If regex3.IsMatch(itemToAdd, prefixTextIndex) Then
                    newLineIndexBeforePrefix = regex3.Match(itemToAdd, prefixTextIndex).Index
                End If
                If (newLineIndexBeforePrefix > -1) Then
                    If itemToAdd.StartsWith("...") Then
                        itemToAdd = ("..." + itemToAdd.Substring((newLineIndexBeforePrefix + regex3.Match(itemToAdd, prefixTextIndex).Length)))
                    Else
                        itemToAdd = itemToAdd.Substring((newLineIndexBeforePrefix + regex3.Match(itemToAdd, prefixTextIndex).Length))
                    End If
                End If

                If Not itemToAdd is nothing AndAlso Not resultList.Contains(itemToAdd) Then
                    resultList.Add(itemToAdd)
                    isAdded = true
                End If
            End If
            Return isAdded
        End Function
        
    
        Protected Overridable Sub GetPageSize()
        
            If Me.OwnerVehiclePagination.PageSize.Text.Trim <> "" Then
                Try
                    'Me.PageSize = Integer.Parse(Me.OwnerVehiclePagination.PageSize.Text)
                Catch ex As Exception
                End Try
            End If
        End Sub

        Protected Overridable Sub AddNewRecords()
            Dim newRecordList As ArrayList = New ArrayList()

            ' Loop though all the record controls and if the record control
            ' does not have a unique record id set, then create a record
            ' and add to the list.
            If Not Me.ResetData Then
                Dim rep As System.Web.UI.WebControls.Repeater = CType(Me.FindControl("OwnerVehicleTableControlRepeater"), System.Web.UI.WebControls.Repeater)

                Dim repItem As System.Web.UI.WebControls.RepeaterItem
                For Each repItem In rep.Items
                    ' Loop through all rows in the table, set its DataSource and call DataBind().
                    Dim recControl As OwnerVehicleTableControlRow = DirectCast(repItem.FindControl("OwnerVehicleTableControlRow"), OwnerVehicleTableControlRow)

                    If recControl.Visible AndAlso recControl.IsNewRecord() Then
                        Dim rec As OwnerVehicleRecord = New OwnerVehicleRecord()
        
                        If MiscUtils.IsValueSelected(recControl.Make) Then
                            rec.Parse(recControl.Make.SelectedItem.Value, OwnerVehicleTable.VehicleTypeId)
                        End If
                        If MiscUtils.IsValueSelected(recControl.Model) Then
                            rec.Parse(recControl.Model.SelectedItem.Value, OwnerVehicleTable.VehicleTypeId)
                        End If
                        If MiscUtils.IsValueSelected(recControl.VehicleTypeId) Then
                            rec.Parse(recControl.VehicleTypeId.SelectedItem.Value, OwnerVehicleTable.VehicleTypeId)
                        End If
                        newRecordList.Add(rec)
                    End If
                Next
            End If

            ' Add any new record to the list.
            Dim index As Integer = 0
            For index = 1 To Me.AddNewRecord
                newRecordList.Insert(0, New OwnerVehicleRecord())
            Next
            Me.AddNewRecord = 0

            ' Finally, add any new records to the DataSource.
            If newRecordList.Count > 0 Then
                Dim finalList As ArrayList = New ArrayList(Me.DataSource)
                finalList.InsertRange(0, newRecordList)

                Me.DataSource = DirectCast(finalList.ToArray(GetType(OwnerVehicleRecord)), OwnerVehicleRecord())
            End If

        End Sub

        
        Public Sub AddToDeletedRecordIds(ByVal rec As OwnerVehicleTableControlRow)
            If rec.IsNewRecord() Then
                Return
            End If

            If Not Me.DeletedRecordIds Is Nothing AndAlso Me.DeletedRecordIds.Trim <> "" Then
                Me.DeletedRecordIds &= ","
            End If

            Me.DeletedRecordIds &= "[" & rec.RecordUniqueId & "]"
        End Sub

        Private Function InDeletedRecordIds(ByVal rec As OwnerVehicleTableControlRow) As Boolean
            If Me.DeletedRecordIds Is Nothing OrElse Me.DeletedRecordIds.Trim = "" Then
                Return False
            End If

            Return Me.DeletedRecordIds.IndexOf("[" & rec.RecordUniqueId & "]") >= 0
        End Function

        Private _DeletedRecordIds As String
        Public Property DeletedRecordIds() As String
            Get
                Return Me._DeletedRecordIds
            End Get

            Set(ByVal value As String)
                Me._DeletedRecordIds = value
            End Set
        End Property
        
        Private Sub Control_PreRender(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.PreRender
            Try
                DbUtils.StartTransaction
                
                If Not Me.Page.ErrorOnPage AndAlso (Me.Page.IsPageRefresh OrElse Me.DataChanged OrElse Me.ResetData) Then
                    Me.LoadData()
                    Me.DataBind()
                End If
                
            Catch ex As Exception
                Utils.MiscUtils.RegisterJScriptAlert(Me, "BUTTON_CLICK_MESSAGE", ex.Message)
            Finally
                DbUtils.EndTransaction
            End Try
        End Sub
        
        Protected Overrides Sub SaveControlsToSession()
            MyBase.SaveControlsToSession()

            ' Save filter controls to values to session.
        
            
            ' Save table control properties to the session.
            If Not Me.CurrentSortOrder Is Nothing Then
                Me.SaveToSession(Me, "Order_By", Me.CurrentSortOrder.ToXmlString())
            End If
            Me.SaveToSession(Me, "Page_Index", Me.PageIndex.ToString())
            Me.SaveToSession(Me, "Page_Size", Me.PageSize.ToString())
        
            Me.SaveToSession(Me, "DeletedRecordIds", Me.DeletedRecordIds)  
        
        End Sub
        
        Protected  Sub SaveControlsToSession_Ajax()
            ' Save filter controls to values to session.
          
            HttpContext.Current.Session("AppRelatvieVirtualPath") = Me.Page.AppRelativeVirtualPath
         
        End Sub
        
        Protected Overrides Sub ClearControlsFromSession()
            MyBase.ClearControlsFromSession()

            ' Clear filter controls values from the session.
        
            
            ' Clear table properties from the session.
            Me.RemoveFromSession(Me, "Order_By")
            Me.RemoveFromSession(Me, "Page_Index")
            Me.RemoveFromSession(Me, "Page_Size")
            
            Me.RemoveFromSession(Me, "DeletedRecordIds")  
            
        End Sub

        Protected Overrides Sub LoadViewState(ByVal savedState As Object)
            MyBase.LoadViewState(savedState)

            Dim orderByStr As String = CType(ViewState("OwnerVehicleTableControl_OrderBy"), String)
            If Not orderByStr Is Nothing AndAlso orderByStr.Trim <> "" Then
                Me.CurrentSortOrder = BaseClasses.Data.OrderBy.FromXmlString(orderByStr)
            Else
                Me.CurrentSortOrder = New OrderBy(True, True)
            End If

            Dim pageIndex As String = CType(ViewState("Page_Index"), String)
            If Not pageIndex Is Nothing Then
                Me.PageIndex = CInt(pageIndex)
            End If

            Dim pageSize As String = CType(ViewState("Page_Size"), String)
            If Not pageSize Is Nothing Then
                Me.PageSize = CInt(pageSize)
            End If
        
            Me.DeletedRecordIds = CType(Me.ViewState("DeletedRecordIds"), String)
        
        End Sub

        Protected Overrides Function SaveViewState() As Object
            
            If Not Me.CurrentSortOrder Is Nothing Then
                Me.ViewState("OwnerVehicleTableControl_OrderBy") = Me.CurrentSortOrder.ToXmlString()
            End If
            
            Me.ViewState("Page_Index") = Me.PageIndex
            Me.ViewState("Page_Size") = Me.PageSize
        
            Me.ViewState("DeletedRecordIds") = Me.DeletedRecordIds
        
            Return MyBase.SaveViewState()

        End Function

        ' Generate the event handling functions for pagination events.
        
        ' event handler for ImageButton
        Public Overridable Sub OwnerVehiclePagination_FirstPage_Click(ByVal sender As Object, ByVal args As ImageClickEventArgs)
        
            Try
                
            Me.PageIndex = 0
            Me.DataChanged = True
      
            Catch ex As Exception
                Me.Page.ErrorOnPage = True
    
                Utils.MiscUtils.RegisterJScriptAlert(Me, "BUTTON_CLICK_MESSAGE", ex.Message)
            Finally
    
            End Try
                  
        End Sub
            
        ' event handler for ImageButton
        Public Overridable Sub OwnerVehiclePagination_LastPage_Click(ByVal sender As Object, ByVal args As ImageClickEventArgs)
        
            Try
                
            Me.DisplayLastPage = True
            Me.DataChanged = True
      
            Catch ex As Exception
                Me.Page.ErrorOnPage = True
    
                Utils.MiscUtils.RegisterJScriptAlert(Me, "BUTTON_CLICK_MESSAGE", ex.Message)
            Finally
    
            End Try
                  
        End Sub
            
        ' event handler for ImageButton
        Public Overridable Sub OwnerVehiclePagination_NextPage_Click(ByVal sender As Object, ByVal args As ImageClickEventArgs)
        
            Try
                
            Me.PageIndex += 1
            Me.DataChanged = True
      
            Catch ex As Exception
                Me.Page.ErrorOnPage = True
    
                Utils.MiscUtils.RegisterJScriptAlert(Me, "BUTTON_CLICK_MESSAGE", ex.Message)
            Finally
    
            End Try
                  
        End Sub
            
        ' event handler for LinkButton
        Public Overridable Sub OwnerVehiclePagination_PageSizeButton_Click(ByVal sender As Object, ByVal args As EventArgs)
              
            Try
                
            Me.DataChanged = True
            Me.PageSize = Integer.Parse(Me.OwnerVehiclePagination.PageSize.Text)
            Me.PageIndex = Integer.Parse(Me.OwnerVehiclePagination.CurrentPage.Text) - 1
          
            Catch ex As Exception
                Me.Page.ErrorOnPage = True
    
                Utils.MiscUtils.RegisterJScriptAlert(Me, "BUTTON_CLICK_MESSAGE", ex.Message)
            Finally
    
            End Try
    
        End Sub
            
        ' event handler for ImageButton
        Public Overridable Sub OwnerVehiclePagination_PreviousPage_Click(ByVal sender As Object, ByVal args As ImageClickEventArgs)
        
            Try
                
            If Me.PageIndex > 0 Then
                Me.PageIndex -= 1
                Me.DataChanged = True
            End If
      
            Catch ex As Exception
                Me.Page.ErrorOnPage = True
    
                Utils.MiscUtils.RegisterJScriptAlert(Me, "BUTTON_CLICK_MESSAGE", ex.Message)
            Finally
    
            End Try
                  
        End Sub
            

        ' Generate the event handling functions for sorting events.
        
        ' event handler for FieldSort
        Public Overridable Sub VehicleTypeIdLabel1_Click(ByVal sender As Object, ByVal args As EventArgs)
              
            Dim sd As OrderByItem = Me.CurrentSortOrder.Find(OwnerVehicleTable.VehicleTypeId)
            If Not sd Is Nothing Then
                sd.Reverse()
            Else
                Me.CurrentSortOrder.Reset()
                Me.CurrentSortOrder.Add(OwnerVehicleTable.VehicleTypeId, OrderByItem.OrderDir.Asc)
            End If

            Me.DataChanged = True
              
        End Sub
            

        ' Generate the event handling functions for button events.
        
        ' event handler for ImageButton
        Public Overridable Sub OwnerVehicleAddButton_Click(ByVal sender As Object, ByVal args As ImageClickEventArgs)
        
            Try
                DbUtils.StartTransaction
                
            Me.AddNewRecord = 1
            Me.DataChanged = True
                Me.Page.CommitTransaction(sender)
          
            Catch ex As Exception
                Me.Page.RollBackTransaction(sender)
                Me.Page.ErrorOnPage = True
    
                Utils.MiscUtils.RegisterJScriptAlert(Me, "BUTTON_CLICK_MESSAGE", ex.Message)
          
            Finally
                DbUtils.EndTransaction
            End Try
                  
        End Sub
            
        ' event handler for ImageButton
        Public Overridable Sub OwnerVehicleDeleteButton_Click(ByVal sender As Object, ByVal args As ImageClickEventArgs)
        
            Try
                DbUtils.StartTransaction
                
            If(Not Me.Page.IsPageRefresh) Then
        
                Me.DeleteSelectedRecords(True)
          
            End If
                Me.Page.CommitTransaction(sender)
          
            Catch ex As Exception
                Me.Page.RollBackTransaction(sender)
                Me.Page.ErrorOnPage = True
    
                Utils.MiscUtils.RegisterJScriptAlert(Me, "BUTTON_CLICK_MESSAGE", ex.Message)
          
            Finally
                DbUtils.EndTransaction
            End Try
                  
        End Sub
            
        ' event handler for ImageButton
        Public Overridable Sub OwnerVehicleEditButton_Click(ByVal sender As Object, ByVal args As ImageClickEventArgs)
        
            Dim url As String = "../Shared/ConfigureEditRecord.aspx"
            Dim shouldRedirect As Boolean = True
            Dim TargetKey As String = Nothing
            Dim DFKA As String = Nothing
            Dim id As String = Nothing
            Dim value As String = Nothing
            Try
                DbUtils.StartTransaction
                
            url = Me.ModifyRedirectUrl(url, "",False)
            url = Me.Page.ModifyRedirectUrl(url, "",False)
                    Me.Page.CommitTransaction(sender)
          
            Catch ex As Exception
                Me.Page.RollBackTransaction(sender)
                shouldRedirect = False
                Me.Page.ErrorOnPage = True
    
                Utils.MiscUtils.RegisterJScriptAlert(Me, "BUTTON_CLICK_MESSAGE", ex.Message)
          
            Finally
                DbUtils.EndTransaction
            End Try
            If shouldRedirect Then
                Me.Page.ShouldSaveControlsToSession = True
                Me.Page.Response.Redirect(url)
            ElseIf Not TargetKey Is Nothing AndAlso _
                        Not shouldRedirect Then
            Me.Page.ShouldSaveControlsToSession = True
            Me.Page.CloseWindow(True)
        
            End If              
        End Sub
            
        ' event handler for ImageButton
        Public Overridable Sub OwnerVehicleRefreshButton_Click(ByVal sender As Object, ByVal args As ImageClickEventArgs)
        
            Try
                
            DirectCast(Me.Page.FindControlRecursively("OwnerRecordControl"), OwnerRecordControl).ResetData = True
                
            DirectCast(Me.Page.FindControlRecursively("OwnerVehicleTableControl"), OwnerVehicleTableControl).ResetData = True
                
            Catch ex As Exception
                Me.Page.ErrorOnPage = True
    
                Utils.MiscUtils.RegisterJScriptAlert(Me, "BUTTON_CLICK_MESSAGE", ex.Message)
          
            Finally
    
            End Try
                  
        End Sub
            
        ' event handler for ImageButton
        Public Overridable Sub OwnerVehicleResetButton_Click(ByVal sender As Object, ByVal args As ImageClickEventArgs)
        
            Try
                
              Me.CurrentSortOrder.Reset()
              If Me.InSession(Me, "Order_By") Then
                  Me.CurrentSortOrder = OrderBy.FromXmlString(Me.GetFromSession(Me, "Order_By", Nothing))
              Else
                  Me.CurrentSortOrder = New OrderBy(True, True)
          
              End If
              

          Me.DataChanged = True
            
            Catch ex As Exception
                Me.Page.ErrorOnPage = True
    
                Utils.MiscUtils.RegisterJScriptAlert(Me, "BUTTON_CLICK_MESSAGE", ex.Message)
          
            Finally
    
            End Try
                  
        End Sub
            

        ' Generate the event handling functions for filter and search events.
        

        ' pagination properties
        Private _PageSize As Integer
        Public Property PageSize() As Integer
            Get
                Return Me._PageSize
            End Get
            Set(ByVal value As Integer)
                Me._PageSize = value
            End Set
        End Property

        Private _PageIndex As Integer
        Public Property PageIndex() As Integer
            Get
                ' Return the PageIndex
                Return Me._PageIndex
            End Get
            Set(ByVal value As Integer)
                Me._PageIndex = value
            End Set
        End Property

        Private _TotalRecords As Integer
        Public Property TotalRecords() As Integer
            Get
                Return Me._TotalRecords
            End Get
            Set(ByVal value As Integer)
                If Me.PageSize > 0 Then
                    Me.TotalPages = CInt(Math.Ceiling(value / Me.PageSize))
                End If

                Me._TotalRecords = value
            End Set
        End Property

        Private _TotalPages As Integer
        Public Property TotalPages() As Integer
            Get
                Return Me._TotalPages
            End Get
            Set(ByVal value As Integer)
                Me._TotalPages = value
            End Set
        End Property

        Private _DisplayLastPage As Boolean
        Public Property DisplayLastPage() As Boolean
            Get
                Return Me._DisplayLastPage
            End Get
            Set(ByVal value As Boolean)
                Me._DisplayLastPage = value
            End Set
        End Property

        Private _DataChanged As Boolean = False
        Public Property DataChanged() As Boolean
            Get
                Return Me._DataChanged
            End Get
            Set(ByVal value As Boolean)
                Me._DataChanged = value
            End Set
        End Property
        
        Private _ResetData As Boolean = False
        Public Property ResetData() As Boolean
            Get
                Return Me._ResetData
            End Get
            Set(ByVal value As Boolean)
                Me._ResetData = value
            End Set
        End Property

        Private _AddNewRecord As Integer = 0
        Public Property AddNewRecord() As Integer
            Get
                Return Me._AddNewRecord
            End Get
            Set(ByVal value As Integer)
                Me._AddNewRecord = value
            End Set
        End Property

        Private _CurrentSortOrder As OrderBy = Nothing
        Public Property CurrentSortOrder() As OrderBy
            Get
                Return Me._CurrentSortOrder
            End Get
            Set(ByVal value As BaseClasses.Data.OrderBy)
                Me._CurrentSortOrder = value
            End Set
        End Property

        Private _DataSource() As OwnerVehicleRecord = Nothing
        Public Property DataSource() As OwnerVehicleRecord ()
            Get
                Return Me._DataSource
            End Get
            Set(ByVal value() As OwnerVehicleRecord)
                Me._DataSource = value
            End Set
        End Property

#Region "Helper Properties"
        
        Public ReadOnly Property OwnerVehicleAddButton() As System.Web.UI.WebControls.ImageButton
            Get
                Return CType(BaseClasses.Utils.MiscUtils.FindControlRecursively(Me, "OwnerVehicleAddButton"), System.Web.UI.WebControls.ImageButton)
            End Get
        End Property
        
        Public ReadOnly Property OwnerVehicleDeleteButton() As System.Web.UI.WebControls.ImageButton
            Get
                Return CType(BaseClasses.Utils.MiscUtils.FindControlRecursively(Me, "OwnerVehicleDeleteButton"), System.Web.UI.WebControls.ImageButton)
            End Get
        End Property
        
        Public ReadOnly Property OwnerVehicleEditButton() As System.Web.UI.WebControls.ImageButton
            Get
                Return CType(BaseClasses.Utils.MiscUtils.FindControlRecursively(Me, "OwnerVehicleEditButton"), System.Web.UI.WebControls.ImageButton)
            End Get
        End Property
        
        Public ReadOnly Property OwnerVehiclePagination() As Training1.UI.IPagination
            Get
                Return CType(BaseClasses.Utils.MiscUtils.FindControlRecursively(Me, "OwnerVehiclePagination"), Training1.UI.IPagination)
          End Get
          End Property
        
        Public ReadOnly Property OwnerVehicleRefreshButton() As System.Web.UI.WebControls.ImageButton
            Get
                Return CType(BaseClasses.Utils.MiscUtils.FindControlRecursively(Me, "OwnerVehicleRefreshButton"), System.Web.UI.WebControls.ImageButton)
            End Get
        End Property
        
        Public ReadOnly Property OwnerVehicleResetButton() As System.Web.UI.WebControls.ImageButton
            Get
                Return CType(BaseClasses.Utils.MiscUtils.FindControlRecursively(Me, "OwnerVehicleResetButton"), System.Web.UI.WebControls.ImageButton)
            End Get
        End Property
        
        Public ReadOnly Property OwnerVehicleTitle() As System.Web.UI.WebControls.Literal
            Get
                Return CType(BaseClasses.Utils.MiscUtils.FindControlRecursively(Me, "OwnerVehicleTitle"), System.Web.UI.WebControls.Literal)
            End Get
        End Property
        
        Public ReadOnly Property OwnerVehicleToggleAll() As System.Web.UI.WebControls.CheckBox
            Get
                Return CType(BaseClasses.Utils.MiscUtils.FindControlRecursively(Me, "OwnerVehicleToggleAll"), System.Web.UI.WebControls.CheckBox)
            End Get
        End Property
        
        Public ReadOnly Property OwnerVehicleTotalItems() As System.Web.UI.WebControls.Label
            Get
                Return CType(BaseClasses.Utils.MiscUtils.FindControlRecursively(Me, "OwnerVehicleTotalItems"), System.Web.UI.WebControls.Label)
            End Get
        End Property
        
        Public ReadOnly Property VehicleTypeIdLabel1() As System.Web.UI.WebControls.LinkButton
            Get
                Return CType(BaseClasses.Utils.MiscUtils.FindControlRecursively(Me, "VehicleTypeIdLabel1"), System.Web.UI.WebControls.LinkButton)
            End Get
        End Property
        
#End Region

#Region "Helper Functions"
        
           Public Overrides Overloads Function ModifyRedirectUrl(url As String, arg As String, ByVal bEncrypt As Boolean) As String
            Dim needToProcess As Boolean = AreAnyUrlParametersForMe(url, arg)
            If (needToProcess) Then
                Dim recCtl As OwnerVehicleTableControlRow = Me.GetSelectedRecordControl()
                If recCtl Is Nothing AndAlso url.IndexOf("{") >= 0 Then
                    ' Localization.
                    Throw New Exception(Page.GetResourceValue("Err:NoRecSelected", "Training1"))
                End If

                Dim rec As OwnerVehicleRecord = Nothing
                If Not recCtl Is Nothing Then
                    rec = recCtl.GetRecord()
                End If
                Return ModifyRedirectUrl(url, arg, rec, bEncrypt)
            End If
            Return url
        End Function
          
        Public Function GetSelectedRecordIndex() As Integer
            Dim counter As Integer = 0
            Dim recControl As OwnerVehicleTableControlRow
            For Each recControl In Me.GetRecordControls()
                If recControl.OwnerVehicleRecordRowSelection.Checked Then
                    Return counter
                End If
                counter += 1
            Next
            Return -1
        End Function
        
        Public Function GetSelectedRecordControl As OwnerVehicleTableControlRow
            Dim selectedList() As OwnerVehicleTableControlRow = Me.GetSelectedRecordControls()
            If selectedList.Length = 0 Then
                Return Nothing
            End If
            Return selectedList(0)
          
        End Function

        Public Function GetSelectedRecordControls() As OwnerVehicleTableControlRow()
        
            Dim selectedList As ArrayList = New ArrayList(25)
            Dim recControl As OwnerVehicleTableControlRow
            For Each recControl In Me.GetRecordControls()
                If recControl.OwnerVehicleRecordRowSelection.Checked Then
                    selectedList.Add(recControl)
                End If
            Next
            Return DirectCast(selectedList.ToArray(GetType(OwnerVehicleTableControlRow)), OwnerVehicleTableControlRow())
          
        End Function

        Public Overridable Sub DeleteSelectedRecords(ByVal deferDeletion As Boolean)
            Dim recList() As OwnerVehicleTableControlRow = Me.GetSelectedRecordControls()
            If recList.Length = 0 Then
                ' Localization.
                Throw New Exception(Page.GetResourceValue("Err:NoRecSelected", "Training1"))
            End If
            
            Dim recCtl As OwnerVehicleTableControlRow
            For Each recCtl In recList
                If deferDeletion Then
                    If Not recCtl.IsNewRecord Then
                
                        Me.AddToDeletedRecordIds(recCtl)
                  
                    End If
                    recCtl.Visible = False
                
                    recCtl.OwnerVehicleRecordRowSelection.Checked = False
                
                Else
                
                    recCtl.Delete()
                    Me.DataChanged = True
                    Me.ResetData = True
                  
                End If
            Next
        End Sub

        Public Function GetRecordControls() As OwnerVehicleTableControlRow()
            Dim recList As ArrayList = New ArrayList()
            Dim rep As System.Web.UI.WebControls.Repeater = CType(Me.FindControl("OwnerVehicleTableControlRepeater"), System.Web.UI.WebControls.Repeater)
            Dim repItem As System.Web.UI.WebControls.RepeaterItem

            For Each repItem In rep.Items
                Dim recControl As OwnerVehicleTableControlRow = DirectCast(repItem.FindControl("OwnerVehicleTableControlRow"), OwnerVehicleTableControlRow)
                recList.Add(recControl)
            Next

            Return DirectCast(recList.ToArray(GetType(OwnerVehicleTableControlRow)), OwnerVehicleTableControlRow())
        End Function

        Public Shadows ReadOnly Property Page() As BaseApplicationPage
            Get
                Return DirectCast(MyBase.Page, BaseApplicationPage)
            End Get
        End Property

#End Region

    

End Class

  
' Base class for the OwnerRecordControl control on the EditOwnerPage page.
' Do not modify this class. Instead override any method in OwnerRecordControl.
Public Class BaseOwnerRecordControl
        Inherits Training1.UI.BaseApplicationRecordControl

        '  To customize, override this method in OwnerRecordControl.
      Protected Overridable Sub Control_Init(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Init

      
      ' Setup the pagination events.
      
          
        ' Setup the filter and search events.
        
      
            ' Register the event handlers.
        
        End Sub

        '  To customize, override this method in OwnerRecordControl.
        Protected Overridable Sub Control_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        
        End Sub

        ' Read data from database.  To customize, override this method in OwnerRecordControl.
        Public Overridable Sub LoadData()        
        
            If Not Me.RecordUniqueId Is Nothing AndAlso Me.RecordUniqueId.Trim <> "" Then
                Me.DataSource = OwnerTable.GetRecord(Me.RecordUniqueId, True)
                Return
            End If
        
            Dim wc As WhereClause = Me.CreateWhereClause()
            
            If wc Is Nothing OrElse Not wc.RunQuery Then
                Me.DataSource = New OwnerRecord()
                
                Return
            End If
            

          
              
            ' Retrieve the record from the database.
            
            Dim recList() As OwnerRecord = OwnerTable.GetRecords(wc, Nothing, 0, 2)
            If recList.Length = 0 Then
                Throw New Exception(Page.GetResourceValue("Err:NoRecRetrieved", "Training1"))
            End If
              
            Me.DataSource = OwnerTable.GetRecord(recList(0).GetID.ToXmlString(), True)
                  
        End Sub

        ' Populate the UI controls using the DataSource.  To customize, override this method in OwnerRecordControl.
        Public Overrides Sub DataBind()

            MyBase.DataBind()

            ' Make sure that the DataSource is initialized.
            If Me.DataSource Is Nothing Then
                Return
            End If
        
      
            ' For each field, check to see if a value is specified.  If a value is specified,
            ' then format the value for display.  If no value is specified, use the default value (formatted).

        
            If Me.DataSource.AddressSpecified Then
                Dim formattedValue As String = Me.DataSource.Format(OwnerTable.Address)
                Me.Address.Text = formattedValue
              
            Else      
                Me.Address.Text = OwnerTable.Address.Format(OwnerTable.Address.DefaultValue)
              
            End If
                    
            If Me.DataSource.OwnerNameSpecified Then
                Dim formattedValue As String = Me.DataSource.Format(OwnerTable.OwnerName)
                Me.OwnerName.Text = formattedValue
              
            Else      
                Me.OwnerName.Text = OwnerTable.OwnerName.Format(OwnerTable.OwnerName.DefaultValue)
              
            End If
                    
            Me.IsNewRecord = True
            If Me.DataSource.IsCreated Then
                Me.IsNewRecord = False
        
                Me.RecordUniqueId = Me.DataSource.GetID.ToXmlString()
            End If

            

            ' Load data for each record and table UI control.
            ' Ordering is important because child controls get 
            ' their parent ids from their parent UI controls.
            
      End Sub


      
        
        ' To customize, override this method in OwnerRecordControl.
        Public Overridable Sub SaveData()

            ' 1. Load the existing record from the database. Since we save the entire record, this ensures 
            ' that fields that are not displayed also properly initialized.
            Me.LoadData()
        
            ' 2. Validate the data.  Override in OwnerRecordControl to add custom validation.
            Me.Validate()

            ' 3. Set the values in the record with data from UI controls.  Override in OwnerRecordControl to set additional fields.
            Me.GetUIData()

            ' 4. Save in the database.
            ' We should not save the record if the data did not change. This
            ' will save a database hit and avoid triggering any database triggers.
            If Me.DataSource.IsAnyValueChanged Then
                ' Save record to database but do not commit.
                ' Auto generated ids are available after saving for use by child (dependent) records.
                Me.DataSource.Save()
              
            End If
            Me.DataChanged = True
            Me.ResetData = True
            ' Reseting of Me.IsNewRecord is moved to Save button's click even handler.
            ' Me.IsNewRecord() = False
            
        End Sub

        ' To customize, override this method in OwnerRecordControl.
        Public Overridable Sub GetUIData()
            
            Me.DataSource.Parse(Me.Address.Text, OwnerTable.Address)
                          
            Me.DataSource.Parse(Me.OwnerName.Text, OwnerTable.OwnerName)
                          
        End Sub

        
      
        ' To customize, override this method in OwnerRecordControl.
        Public Overridable Function CreateWhereClause() As WhereClause
        
            Dim wc As WhereClause
            OwnerTable.Instance.InnerFilter = Nothing
            wc = New WhereClause()
            ' Compose the WHERE clause consiting of:
            ' 1. Static clause defined at design time.
            ' 2. User selected filter criteria.
            ' 3. User selected search criteria.
            
            
            ' Retrieve the record id from the URL parameter.
              
            Dim recId As String = Me.Page.Request.QueryString.Item("Owner")
                
            If recId Is Nothing OrElse recId.Trim = "" Then
                ' Get the error message from the application resource file.
                Throw New Exception(Page.GetResourceValue("Err:UrlParamMissing", "Training1").Replace("{URL}", "Owner"))
            End If
            HttpContext.Current.Session("SelectedID") = recId
              
            If KeyValue.IsXmlKey(recId) Then
                Dim pkValue As KeyValue = KeyValue.XmlToKey(recId)
                
                wc.iAND(OwnerTable.Id0, BaseFilter.ComparisonOperator.EqualsTo, pkValue.GetColumnValue(OwnerTable.Id0).ToString())
            Else
                
                wc.iAND(OwnerTable.Id0, BaseFilter.ComparisonOperator.EqualsTo, recId)
            End If
              

            
            Return wc
          
        End Function
        
        ' This CreateWhereClause is used for loading list of suggestions for Auto Type-Ahead feature.
        Public Overridable Function CreateWhereClause(ByVal searchText as String, ByVal fromSearchControl as String, ByVal AutoTypeAheadSearch as String, ByVal AutoTypeAheadWordSeparators as String) As WhereClause
            OwnerTable.Instance.InnerFilter = Nothing
            Dim wc As WhereClause = New WhereClause()
            ' Compose the WHERE clause consiting of:
            ' 1. Static clause defined at design time.
            ' 2. User selected filter criteria.
            ' 3. User selected search criteria.
            Dim appRelativeVirtualPath As String = CType(HttpContext.Current.Session("AppRelatvieVirtualPath"), String)
          
            ' Adds clauses if values are selected in Filter controls which are configured in the page.
          
            Return wc
        End Function
          
          
        'Formats the resultItem and adds it to the list of suggestions.
        Public Overridable Function FormatSuggestions(ByVal prefixText As String, ByVal resultItem as String, _
                                                 ByVal columnLength As Integer, ByVal AutoTypeAheadDisplayFoundText as String, _
                                                 ByVal autoTypeAheadSearch as String, ByVal AutoTypeAheadWordSeparators as String, _
                                                 ByVal resultList as ArrayList) as Boolean
            Dim index As Integer = InvariantLCase(resultItem).IndexOf(InvariantLCase(prefixText))
            Dim itemToAdd As String = ""
            Dim isFound as Boolean = False
            Dim isAdded as Boolean = False
            ' Get the index where prfixt is at the beginning of resultItem. If not found then, index of word which begins with prefixText.
            If InvariantLCase(autoTypeAheadSearch).equals("wordsstartingwithsearchstring") and not index = 0 Then
                ' Expression to find word which contains AutoTypeAheadWordSeparators followed by prefixText
                Dim regex1 As System.Text.RegularExpressions.Regex = new System.Text.RegularExpressions.Regex( AutoTypeAheadWordSeparators + prefixText, System.Text.RegularExpressions.RegexOptions.IgnoreCase)
                If regex1.IsMatch(resultItem) Then
                    index = regex1.Match(resultItem).Index
                    isFound = True
                End If
                ' If the prefixText is found immediatly after white space then starting of the word is found so don not search any further
                If not resultItem(index).ToString() = " " Then
                    ' Expression to find beginning of the word which contains AutoTypeAheadWordSeparators followed by prefixText
                    Dim regex As System.Text.RegularExpressions.Regex = new System.Text.RegularExpressions.Regex("\\S*" + AutoTypeAheadWordSeparators + prefixText, System.Text.RegularExpressions.RegexOptions.IgnoreCase)
                    If regex.IsMatch(resultItem) Then
                        index = regex.Match(resultItem).Index
                        isFound = True
                    End If
                 End If
            End If
            ' If autoTypeAheadSearch value is wordsstartingwithsearchstring then, extract the substring only if the prefixText is found at the 
            ' beginning of the resultItem (index = 0) or a word in resultItem is found starts with prefixText. 
            If index = 0 Or isFound Or InvariantLCase(autoTypeAheadSearch).Equals("anywhereinstring") then
                If InvariantLCase(AutoTypeAheadDisplayFoundText).equals("atbeginningofmatchedstring") Then
                    ' Expression to find beginning of the word which contains prefixText
                    Dim regex1 As System.Text.RegularExpressions.Regex = new System.Text.RegularExpressions.Regex("\\S*" + prefixText, System.Text.RegularExpressions.RegexOptions.IgnoreCase)
                    '  Find the beginning of the word which contains prefexText
                    If (StringUtils.InvariantLCase(autoTypeAheadSearch).Equals("anywhereinstring") AndAlso regex1.IsMatch(resultItem)) Then
                        index = regex1.Match(resultItem).Index
                        isFound = True
                    End If
                    ' Display string from the index till end of the string if sub string from index till end is less than columnLength value.
                    If Len(resultItem) - index <= columnLength Then
                        If index = 0 Then 
                            itemToAdd = resultItem 
                        Else
                            itemToAdd = "..." & resultItem.Substring(index, Len(resultItem) - index) 
                        End If
                    Else
                        If index = 0 Then
                            itemToAdd = resultItem.Substring(index, (columnLength - 3)) & "..."
                        Else
                            'Truncate the string to show only columnLength - 6 characters as begining and trailing "..." has to be appended.
                            itemToAdd = "..." & resultItem.Substring(index , columnLength - 6) & "..." 
                        End If
                    End If
                ElseIf InvariantLCase(AutoTypeAheadDisplayFoundText).equals("inmiddleofmatchedstring") Then
                    Dim subStringBeginIndex as Integer = CType(columnLength/2, Integer)
                    If Len(resultItem) <= columnLength Then
                        itemToAdd = resultItem
                    Else
                        ' Sanity check at end of the string
                        If index + Len(prefixText) = columnLength Then
                            itemToAdd =  "..." & resultItem.Substring(index-columnLength,index)
                        ElseIf Len(resultITem) - index < subStringBeginIndex Then 
                            ' Display string from the end till columnLength value if, index is closer to the end of the string.
                            itemToAdd =  "..." & resultItem.Substring(Len(resultItem)-columnLength,Len(resultItem))
                        ElseIf index <= subStringBeginIndex Then 
                            ' Sanity chet at beginning of the string
                            itemToAdd =  resultItem.Substring(0, columnLength) & "..."
                        Else
                            ' Display string containing text before the prefixText occures and text after the prefixText
                            itemToAdd =  "..." & resultItem.Substring(index - subStringBeginIndex, columnLength) & "..." 
                        End If
                    End If
                ElseIf InvariantLCase(AutoTypeAheadDisplayFoundText).equals("atendofmatchedstring") Then
                     ' Expression to find ending of the word which contains prefexText
                    Dim regex1 as System.Text.RegularExpressions.Regex = new System.Text.RegularExpressions.Regex("\s", System.Text.RegularExpressions.RegexOptions.IgnoreCase)
                    ' Find the ending of the word which contains prefexText
                    If regex1.IsMatch(resultItem, index + 1) Then
                        index = regex1.Match(resultItem, index + 1).Index
                    Else
                        ' If the word which contains prefexText is the last word in string, regex1.IsMatch returns false.
                        index = resultItem.Length
                    End If
                    If index > Len(resultItem) Then
                        index = Len(resultItem)
                    End If
                    ' If text from beginning of the string till index is less than columnLength value then, display string from the beginning till index.
                    If  index <= columnLength Then
                        if index = Len(resultItem) then   'Make decision to append "..."
                            itemToAdd = resultItem.Substring(0,index)
                        Else
                            itemToAdd = resultItem.Substring(0,index) & "..."
                        End If
                    Else
                        If index = Len(resultItem) Then
                            itemToAdd = "..." & resultItem.Substring(index - (columnLength - 3), (columnLength - 3))
                        Else
                            'Truncate the string to show only columnLength - 6 characters as begining and trailing "..." has to be appended.
                            itemToAdd = "..." & resultItem.Substring(index - (columnLength - 6), columnLength - 6) & "..." 
                        End If
                    End If
                End If
                
                ' Remove newline character from itemToAdd
                Dim prefixTextIndex As Integer = itemToAdd.IndexOf(prefixText, StringComparison.InvariantCultureIgnoreCase)
                ' If itemToAdd contains any newline after the search text then show text only till newline
                Dim regex2 As System.Text.RegularExpressions.Regex = New System.Text.RegularExpressions.Regex("(" & vbCrLf & "|" & vbLf & ")", System.Text.RegularExpressions.RegexOptions.IgnoreCase)
                Dim newLineIndexAfterPrefix As Integer = -1
                If regex2.IsMatch(itemToAdd, prefixTextIndex) Then
                    newLineIndexAfterPrefix = regex2.Match(itemToAdd, prefixTextIndex).Index
                End If
                If (newLineIndexAfterPrefix > -1) Then
                    If itemToAdd.EndsWith("...") Then
                        itemToAdd = (itemToAdd.Substring(0, newLineIndexAfterPrefix) + "...")
                    Else
                        itemToAdd = itemToAdd.Substring(0, newLineIndexAfterPrefix)
                    End If
                End If
                ' If itemToAdd contains any newline before search text then show text which comes after newline
                Dim regex3 As System.Text.RegularExpressions.Regex = New System.Text.RegularExpressions.Regex("(" & vbCrLf & "|" & vbLf & ")", (System.Text.RegularExpressions.RegexOptions.IgnoreCase Or System.Text.RegularExpressions.RegexOptions.RightToLeft))
                Dim newLineIndexBeforePrefix As Integer = -1
                If regex3.IsMatch(itemToAdd, prefixTextIndex) Then
                    newLineIndexBeforePrefix = regex3.Match(itemToAdd, prefixTextIndex).Index
                End If
                If (newLineIndexBeforePrefix > -1) Then
                    If itemToAdd.StartsWith("...") Then
                        itemToAdd = ("..." + itemToAdd.Substring((newLineIndexBeforePrefix + regex3.Match(itemToAdd, prefixTextIndex).Length)))
                    Else
                        itemToAdd = itemToAdd.Substring((newLineIndexBeforePrefix + regex3.Match(itemToAdd, prefixTextIndex).Length))
                    End If
                End If

                If Not itemToAdd is nothing AndAlso Not resultList.Contains(itemToAdd) Then
                    resultList.Add(itemToAdd)
                    isAdded = true
                End If
            End If
            Return isAdded
        End Function
        

        ' To customize, override this method in OwnerRecordControl.
        Public Overridable Sub Validate() 
            ' Initially empty.  Override to add custom validation.
        End Sub

        Public Overridable Sub Delete()
        
            If Me.IsNewRecord() Then
                Return
            End If

            Dim pk As KeyValue = KeyValue.XmlToKey(Me.RecordUniqueId)
            OwnerTable.DeleteRecord(pk)

          
        End Sub

        Private Sub Control_PreRender(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.PreRender
            Try
                DbUtils.StartTransaction()

                If Not Me.Page.ErrorOnPage AndAlso (Me.Page.IsPageRefresh OrElse Me.DataChanged OrElse Me.ResetData) Then
                    Me.LoadData()
                    Me.DataBind()
                End If

            Catch ex As Exception
                Utils.MiscUtils.RegisterJScriptAlert(Me, "BUTTON_CLICK_MESSAGE", ex.Message)
            Finally
                DbUtils.EndTransaction()
            End Try
        End Sub
        
        

        Protected Overrides Sub LoadViewState(ByVal savedState As Object)
            MyBase.LoadViewState(savedState)
            Dim isNewRecord As String = CType(ViewState("IsNewRecord"), String)
            If Not isNewRecord Is Nothing AndAlso isNewRecord.Trim <> "" Then
                Me.IsNewRecord = Boolean.Parse(isNewRecord)
            End If
            
            Dim myCheckSum As String = CType(ViewState("CheckSum"), String)
            If Not myCheckSum Is Nothing AndAlso myCheckSum.Trim <> "" Then
                Me.CheckSum = myCheckSum
            End If
            
        End Sub

        Protected Overrides Function SaveViewState() As Object
            ViewState("IsNewRecord") = Me.IsNewRecord.ToString()
            ViewState("CheckSum") = Me.CheckSum
            
            Return MyBase.SaveViewState()
        End Function
        
        
        ' Generate the event handling functions for pagination events.
            
      
        ' Generate the event handling functions for filter and search events.
            
      
        Private _IsNewRecord As Boolean = True
        Public Overridable Property IsNewRecord() As Boolean
            Get
                Return Me._IsNewRecord
            End Get
            Set(ByVal value As Boolean)
                Me._IsNewRecord = value
            End Set
        End Property

        Private _DataChanged As Boolean = False
        Public Overridable Property DataChanged() As Boolean
            Get
                Return Me._DataChanged
            End Get
            Set(ByVal Value As Boolean)
                Me._DataChanged = Value
            End Set
        End Property

        Private _ResetData As Boolean = False
        Public Overridable Property ResetData() As Boolean
            Get
                Return Me._ResetData
            End Get
            Set(ByVal Value As Boolean)
                Me._ResetData = Value
            End Set
        End Property
        
        Public Property RecordUniqueId() As String
            Get
                Return CType(Me.ViewState("BaseOwnerRecordControl_Rec"), String)
            End Get
            Set(ByVal value As String)
                Me.ViewState("BaseOwnerRecordControl_Rec") = value
            End Set
        End Property
        
        Private _DataSource As OwnerRecord
        Public Property DataSource() As OwnerRecord
            Get
                Return Me._DataSource
            End Get
            Set(ByVal value As OwnerRecord)
                Me._DataSource = value
            End Set
        End Property

        Private _checkSum As String
        Public Overridable Property CheckSum() As String
            Get
                Return Me._checkSum
            End Get
            Set(ByVal value As String)
                Me._checkSum = value
            End Set
        End Property
        
        Private _TotalPages As Integer
        Public Property TotalPages() As Integer
            Get
                Return Me._TotalPages
            End Get
            Set(ByVal value As Integer)
                Me._TotalPages = value
            End Set
        End Property
        
        Private _PageIndex As Integer
        Public Property PageIndex() As Integer
            Get
                ' Return the PageIndex
                Return Me._PageIndex
            End Get
            Set(ByVal value As Integer)
                Me._PageIndex = value
            End Set
        End Property
        
        Private _DisplayLastPage As Boolean
        Public Property DisplayLastPage() As Boolean
            Get
                Return Me._DisplayLastPage
            End Get
            Set(ByVal value As Boolean)
                Me._DisplayLastPage = value
            End Set
        End Property
        
        

#Region "Helper Properties"
        
        Public ReadOnly Property Address() As System.Web.UI.WebControls.TextBox
            Get
                Return CType(BaseClasses.Utils.MiscUtils.FindControlRecursively(Me, "Address"), System.Web.UI.WebControls.TextBox)
            End Get
        End Property
            
        Public ReadOnly Property AddressLabel() As System.Web.UI.WebControls.Literal
            Get
                Return CType(BaseClasses.Utils.MiscUtils.FindControlRecursively(Me, "AddressLabel"), System.Web.UI.WebControls.Literal)
            End Get
        End Property
        
        Public ReadOnly Property OwnerName() As System.Web.UI.WebControls.TextBox
            Get
                Return CType(BaseClasses.Utils.MiscUtils.FindControlRecursively(Me, "OwnerName"), System.Web.UI.WebControls.TextBox)
            End Get
        End Property
            
        Public ReadOnly Property OwnerNameLabel() As System.Web.UI.WebControls.Literal
            Get
                Return CType(BaseClasses.Utils.MiscUtils.FindControlRecursively(Me, "OwnerNameLabel"), System.Web.UI.WebControls.Literal)
            End Get
        End Property
        
        Public ReadOnly Property OwnerTitle() As System.Web.UI.WebControls.Literal
            Get
                Return CType(BaseClasses.Utils.MiscUtils.FindControlRecursively(Me, "OwnerTitle"), System.Web.UI.WebControls.Literal)
            End Get
        End Property
        
#End Region

#Region "Helper Functions"

        Public Overrides Overloads Function ModifyRedirectUrl(ByVal url As String, ByVal arg As String, ByVal bEncrypt As Boolean) As String
            Dim rec As OwnerRecord = Nothing
            
            Try
                rec = Me.GetRecord()
            Catch ex As Exception
                ' Do nothing
            End Try

            If rec Is Nothing AndAlso url.IndexOf("{") >= 0 Then
                ' Localization.
                
            Throw New Exception(Page.GetResourceValue("Err:RecDataSrcNotInitialized", "Training1"))
                    
            End If
            Return ModifyRedirectUrl(url, arg, rec, bEncrypt)
        End Function

        Public Function GetRecord() As OwnerRecord
            If Not Me.DataSource Is Nothing Then
                Return Me.DataSource
            End If
            
            If Not Me.RecordUniqueId Is Nothing Then
                Return OwnerTable.GetRecord(Me.RecordUniqueId, True)
            End If
            
            ' Localization.
            
            Throw New Exception(Page.GetResourceValue("Err:RetrieveRec", "Training1"))
                
        End Function

        Public Shadows ReadOnly Property Page() As BaseApplicationPage
            Get
                Return DirectCast(MyBase.Page, BaseApplicationPage)
            End Get
        End Property

#End Region

End Class

  

#End Region
    
  
End Namespace

  